﻿//*****************************************************************************
//* Copyright (c) 2012 Miday Workshop All rights reserved.
//*
//* File: CalcCom.cpp
//*****************************************************************************

#ifdef _WINDOWS_PLAT
#include <windows.h>
#else  //_WINDOWS_PLAT
#include <stdint.h>
#endif  //_WINDOWS_PLAT
#include <new>
#include <string.h>
#include <wchar.h>
#include "CalcDef.h"
#include "MsgLocale.h"

//パラメータ入力の変数
UNICHAR AppPath[FILENAME_SIZE];    //アプリケーションパス
UNICHAR Inifile[FILENAME_SIZE];    //InitFile名
int ClipWaitCount, ClipWaitTime, TimeLog, AsciiWide, HoriWide;
#ifdef _UNICODE_TABLE
wchar_t Locale[500];
#endif  //_UNICODE_TABLE
UNICHAR Evasion[50];

#ifdef _WINDOWS_PLAT
SYSTEMTIME Just1, Just2;
#else  //_WINDOWS_PLAT
#include <time.h>
struct tm *Just1, *Just2;
#endif  //_WINDOWS_PLAT

CELL *hyo;
#if defined(_JPN) || defined(_ENG)
POS *yoko_p;
POS *tate_p;
#endif  //_JPN _ENG
CHAR_LEN out_data;
CHAR_LEN out_wk_data;
UNICHAR *clip_data;
int *font_attr;
int *cell_attr;

int Col_no, Row_no;
int irc;
int Verno;

int Break_flag;//=0 キャンセル未　=1 キャンセル中　=2 キャンセル処理終了
int Allline_flag;//=0 確認未　=1 全ての枠線を付けることを確認ずみ
int Area_pos;//領域確保処理はどこまで進んだか
int Out_alloc;//出力用の領域を確保したか
int Out_wk_alloc;//作業用の領域を確保したか
int Clip_alloc;//クリップボートからデータを取り込んだか
int Proc_pos;//実行処理はどの時点か
int Use_pos;//変数使用処理はどこまで進んだか
int Use_flag[10];//変数は使用しているか

int font_attr_maxno;//文字属性データの数
int font_attr_no;//現在使用中の文字属性データの番号
int font_attr_alloc;//文字属性データの領域を確保したか
int cell_attr_maxno;//セル属性データの数
int cell_attr_no;//現在使用中のセル属性データの番号
int cell_attr_alloc;//セル属性データの領域を確保したか

int text_flag;//クリップボードのデータのタイプ　IN_TEXTDATA/IN_UNIDATA/IN_CALCDATA

//==============================================================================
//文字列の指定範囲に1バイト文字が幾つあるかチェックする
//==============================================================================
int HalfCheck(UNICHAR *indata, int sa, int ea) {
	int ja, ma;
	ja = 0;
	for(ma=sa; ma<=ea; ma++) {
#ifdef _UNICODE_TABLE
		if ( indata[ma] >= LIT_K61 && indata[ma] <= LIT_K9F ) {
			ja++;
		} else {
#endif  //_UNICODE_TABLE
			if ( indata[ma] < LIT_KFF ) {
				ja++;
			}
#ifdef _UNICODE_TABLE
		}
#endif  //_UNICODE_TABLE
	}
	return ja;
}

//==============================================================================
//領域を確保する
//==============================================================================
int AllocArea() {
	int ia, irc;

	try{
		hyo    = new CELL[(Col_no)*(Row_no)];
		Area_pos = 1;
		for (ia=0; ia<Col_no*Row_no; ia++ ) {
			hyo[ia].text.size = -1;
//			hyo[ia].type = CELL_TYPE_TEXT;
			hyo[ia].merge[AR_FLAG] = 0;
			hyo[ia].merge[AR_BASE] = 0;
		}

#if defined(_JPN) || defined(_ENG)
		yoko_p = new POS[Col_no];
#endif  //_JPN _ENG
		Area_pos = 2;
#if defined(_JPN) || defined(_ENG)
		tate_p = new POS[Row_no];
#endif  //_JPN _ENG
		Area_pos = 3;
#if defined(_JPN) || defined(_ENG)
		for ( ia=0; ia<Col_no; ia++ ) {
			yoko_p[ia].posp = 0;
			yoko_p[ia].posw = 0;
		}
		for ( ia=0; ia<Row_no; ia++ ) {
			tate_p[ia].posp = 0;
			tate_p[ia].posw = 0;
		}
#endif  //_JPN _ENG

	}
#if _MSC_VER > 1200
	catch (std::bad_alloc) {
#else  //MSC
//VC6 以下
	catch (...) {
#endif  //MSC
		irc = MessageDisp( MSG_ER_MEM2_CODE );
		return MEMORY_ERROR;
	}
#if _MSC_VER > 1200
	catch (...) {
		irc = MessageDisp( MSG_ER_MEM3_CODE );
		return MEMORY_ERROR;
	}
#endif  //MSC
	return NOMAL_RETURN;
}

//==============================================================================
//領域を開放する out_dataとclip_dataも開放
//==============================================================================
void FreeArea() {
//以下は原則
//キャンセルかメモリエラー　このファイルから呼ぶ
//OLE エラー　　　　　　　　AutoWrapから呼ぶ
//その他のエラー　　　　　　CalcGetから呼ぶ
	int ia;
	if ( Area_pos >= 1 ) {
		for (ia=0; ia<Col_no*Row_no; ia++ ) {
			if ( hyo[ia].text.size != -1 ) {
				CharLenFree(&hyo[ia].text);
			}
		}
		delete[] hyo;
	}
#if defined(_JPN) || defined(_ENG)
	if ( Area_pos >= 2 ) delete[] yoko_p;
	if ( Area_pos >= 3 ) delete[] tate_p;
#endif  //_JPN _ENG
	Area_pos         = 0;

#ifdef _WINDOWS_PLAT
//linuxは、destroy_progress　で行う
	if ( Out_alloc == 1 ) CharLenFree(&out_data);
	Out_alloc        = 0;
#endif  //_WINDOWS_PLAT

	if ( Out_wk_alloc == 1 ) CharLenFree(&out_wk_data);
	Out_wk_alloc     = 0;

	if ( Clip_alloc == 1 ) delete[] clip_data;
	Clip_alloc       = 0;

	if ( font_attr_alloc == 1 ) delete[] font_attr;
	font_attr_alloc  = 0;

	if ( cell_attr_alloc == 1 ) delete[] cell_attr;
	cell_attr_alloc  = 0;
}

//==============================================================================
//指定された文字の先頭バイトをチェックし、後ろに何バイトあるかを返す
//シフトJIS EUC-JP の処理
//==============================================================================
int ByteChk(UNICHAR ch) {
#ifdef _WINDOWS_PLAT
	return 0;
#ifdef _UNICODE_TABLE
#else  //_UNICODE_TABLE
	//シフトJIS
	if ((ch >= LIT_H81 && ch <= LIT_H9F) || (ch >= LIT_HE0 && ch <= LIT_HFC)) {
		return 1;
	}
#endif  //_UNICODE_TABLE
#else  //_WINDOWS_PLAT
#ifdef _UNICODE_TABLE
	return 0;
#else  //_UNICODE_TABLE
	//EUC-JP   テストしていない
	if ((ch == LIT_H8E) || (ch >= LIT_HA1 && ch <= LIT_HFE)) {
		return 1;
	} else if (ch == LIT_H8F) {
		return 2;
	}
#endif  //_UNICODE_TABLE
#endif  //_WINDOWS_PLAT
	return 0;
}

//==============================================================================
//クリップボードから取り込んだデータを分割する
//Col_no と Row_no の外部変数にも値を設定する
//メモリを確保するときに Col_no と Row_no を使用する
//==============================================================================
int DataDivision(UNICHAR *indata) {
//indata　 クリップボードのデータ
	int ia, ib, ic, ip, ir, is;

//------------------------------------------------------------------------------
//表の枠数を求める
//------------------------------------------------------------------------------
	ib = 1;
	Col_no = 0;
	Row_no = 1;
	for (ia=0; ia<(int)MTRLEN(indata); ia++ ) {
		if (indata[ia] == LIT_TAB_C ) {
			ib++;
		}
		if (indata[ia] == LIT_HLF ) {  //CR-LF のLF    mac非対応
			if ( ib > Col_no ) {
				Col_no = ib;
			}
			if ( ia != (int)MTRLEN(indata) - 1 ) {
				(Row_no)++;
			}
			ib = 1;
		}
		ia = ia + ByteChk(indata[ia]);
	}
	if ( ib > Col_no ) Col_no = ib;

//------------------------------------------------------------------------------
//表の枠に値を設定
//------------------------------------------------------------------------------
	//領域確保
	if ( AllocArea() != 0 ) {
		return MEMORY_ERROR;
	}

	for ( ir=0; ir<(Row_no); ir++ ) {
		for ( ib=0; ib<(Col_no); ib++ ) {
			for ( ip=0; ip<4; ip++ ) {
				hyo[(Col_no)*ir+ib].line[ip]   = 0;
#if defined(_WIKI) || defined(_HTML)
				hyo[(Col_no)*ir+ib].lcolor[ip] = (unsigned int)0x00000000;//黒
#endif  //_WIKI _HTML
			}
#if defined(_WIKI) || defined(_HTML)
			hyo[(Col_no)*ir+ib].fcolor        = (unsigned int)0x00000000;//黒
			hyo[(Col_no)*ir+ib].size          = 10;//デフォルト
			hyo[(Col_no)*ir+ib].bold          = false;//デフォルト
			hyo[(Col_no)*ir+ib].italic        = false;//デフォルト
			hyo[(Col_no)*ir+ib].underline     = FONT_UNDERLINE_NONE;//デフォルト
			hyo[(Col_no)*ir+ib].strikethrough = 0;//デフォルト
			hyo[(Col_no)*ir+ib].bcolor        = (unsigned int)0x00ffffff;//白
#endif  //_WIKI _HTML
		}
	}

	ib = 0;
	ir = 0;
	is = 0;
	if ( (Col_no)*ir+ib < (Col_no)*(Row_no) ) {
		if ( CharLenNewAlloc(&hyo[(Col_no)*ir+ib].text, MTRLEN(indata)) == MEMORY_ERROR ) {
			return MEMORY_ERROR;
		}
	}
	for ( ia=0; ia<(int)MTRLEN(indata); ia++ ) {
		if (indata[ia] == LIT_TAB_C ) {
			if(ia-is > 0) {
				MTRNCPY(hyo[(Col_no)*ir+ib].text.data, hyo[(Col_no)*ir+ib].text.size+1, &indata[is], ia-is);
				hyo[(Col_no)*ir+ib].text.data[ia-is] = LIT_NULL_C;
			} else {
				hyo[(Col_no)*ir+ib].text.data[0] = LIT_NULL_C;
			}
			is = ia + 1;
			ib++;
			if ( (Col_no)*ir+ib < (Col_no)*(Row_no) ) {
				if ( CharLenNewAlloc(&hyo[(Col_no)*ir+ib].text, MTRLEN(indata)) == MEMORY_ERROR ) {
					return MEMORY_ERROR;
				}
				for ( ip=0; ip<4; ip++ ) {
					hyo[(Col_no)*ir+ib].line[ip] = 0;
				}
			}
		}
		if (indata[ia] == LIT_HLF ) {  //CR-LF のLF    mac非対応
			if (indata[ia-1] == LIT_HCR ) {  //CR-LF のCR
				ic = 1;
			} else {
				ic = 0;
			}
			if(ia-is > 0) {
				MTRNCPY(hyo[(Col_no)*ir+ib].text.data, hyo[(Col_no)*ir+ib].text.size+1, &indata[is], ia-is-ic);
				hyo[(Col_no)*ir+ib].text.data[ia-is-ic] = LIT_NULL_C;
			} else {
				hyo[(Col_no)*ir+ib].text.data[0] = LIT_NULL_C;
			}
			is = ia + 1;
			ir++;
			ib = 0;
			if ( (Col_no)*ir+ib < (Col_no)*(Row_no) ) {
				if ( CharLenNewAlloc(&hyo[(Col_no)*ir+ib].text, MTRLEN(indata)) == MEMORY_ERROR ) {
					return MEMORY_ERROR;
				}
				for ( ip=0; ip<4; ip++ ) {
					hyo[(Col_no)*ir+ib].line[ip] = 0;
				}
			}
		}
		ia = ia + ByteChk(indata[ia]);
	}
	if (is != (int)MTRLEN(indata) ) {
		if(MTRLEN(indata)-is+1 > 0) {
			MTRNCPY(hyo[(Col_no)*ir+ib].text.data, hyo[(Col_no)*ir+ib].text.size+1, &indata[is], MTRLEN(indata)-is);
			hyo[(Col_no)*ir+ib].text.data[MTRLEN(indata)-is] = LIT_NULL_C;
		} else {
			hyo[(Col_no)*ir+ib].text.data[0] = LIT_NULL_C;
		}

//MessageBoxW(NULL, hyo[(Col_no)*ir+ib].text.data, indata, 0);
	}
	return NOMAL_RETURN;
}
