﻿//*****************************************************************************
//* Copyright (c) 2005-2015 Miday Workshop All rights reserved.
//*
//* File: CalcDef.h
//*****************************************************************************

//------------------------------------------------------------------------------
//定数定義
//------------------------------------------------------------------------------
#define CELL_TYPE_EMPTY    0
#define CELL_TYPE_VALUE    1
#define CELL_TYPE_TEXT     2
#define CELL_TYPE_FORMULA  3

#define CELL_HORI_STANDARD 0
#define CELL_HORI_LEFT     1
#define CELL_HORI_CENTER   2
#define CELL_HORI_RIGHT    3
#define CELL_HORI_BLOCK    4

#define CELL_VERT_STANDARD 0
#define CELL_VERT_TOP      1
#define CELL_VERT_CENTER   2
#define CELL_VERT_BOTTOM   3

#define FONT_WEIGHT_BOLD    150.0
#define FONT_SLANT_ITALIC   2
#define FONT_UNDERLINE_NONE 0

//Calcとは関係無い定義
#define AR_LEFT    0
#define AR_RIGHT   1
#define AR_TOP     2
#define AR_BOTTOM  3
#define AR_FLAG    4
#define AR_WIDTH   5
#define AR_HEIGHT  6
#define AR_BASE    7

#define IN_NOTDATA     0
#define IN_TEXTDATA    1
#define IN_UNIDATA     2
#define IN_CALCDATA    3

#define NOMAL_RETURN      0
#define MEMORY_ERROR      101
#define CANCEL_RETURN     102
#define TEXT_RETURN       108
#define OLE_ERROR         109
#define SDK_ERROR         110
#define FINISHING_MESSAGE 120

#define FONT_AT_COLOR         0
#define FONT_AT_SIZE          1
#define FONT_AT_BOLD          2
#define FONT_AT_ITALIC        3
#define FONT_AT_UNDERLINE     4
#define FONT_AT_STRIKETHROUGH 5
#define FONT_AT_NO            6

#define CELL_AT_BCOLOR        0
#define CELL_AT_LCOLOR        1
#define CELL_AT_NO            2

#define RUN_COUMT             20


//変換処理で使用する文字列操作
#if !defined(_MSC_VER) || _MSC_VER < 1400
#ifdef _UNICODE_TABLE
#define MTRCPY(a,len,b)    wcscpy(a, b)
#define MTRCAT(a,len,b)    wcscat(a, b)
#define MTRNCPY(a,len,b,c) wcsncpy(a, b, c)
#define MTRNCAT(a,len,b,c) wcsncat(a, b, c)
#else  //_UNICODE_TABLE
#define MTRCPY(a,len,b)    strcpy(a, b)
#define MTRCAT(a,len,b)    strcat(a, b)
#define MTRNCPY(a,len,b,c) strncpy(a, b, c)
#define MTRNCAT(a,len,b,c) strncat(a, b, c)
#endif  //_UNICODE_TABLE
//#define WCSTOMBS(len1,a,len2,b,c) wcstombs(a, b, c)  使用していない
//#define SPRINTF(a,len1,...) sprintf(a, ...)
//#define SPRINTF(a,len1,...) sprintf(a, __VA_ARGS__)
#else  //MSC
#ifdef _UNICODE_TABLE
#define MTRCPY(a,len,b)    wcscpy_s(a, len, b)
#define MTRCAT(a,len,b)    wcscat_s(a, len, b)
#define MTRNCPY(a,len,b,c) wcsncpy_s(a, (rsize_t)len, b, c)  //bug VC2005 SP1でOK?
//#define MTRNCPY(a,len,b,c) wcsncpy(a, b, c)
#define MTRNCAT(a,len,b,c) wcsncat_s(a, (rsize_t)len, b, c)
#else  //_UNICODE_TABLE
#define MTRCPY(a,len,b)    strcpy_s(a, len, b)
#define MTRCAT(a,len,b)    strcat_s(a, len, b)
#define MTRNCPY(a,len,b,c) strncpy_s(a, len, b, c)  //bug VC2005 SP1でOK?
//#define MTRNCPY(a,len,b,c) memcpy_s(a, (rsize_t)len, b, c)
#define MTRNCAT(a,len,b,c) strncat_s(a, (rsize_t)len, b, c)
//#define WCSTOMBS(len1,a,len2,b,c) wcstombs_s(len1, a, len2, b, c)  使用していない
//#define SPRINTF(a,len1,...) sprintf(a, len1, ...)
#endif  //_UNICODE_TABLE
#endif  //MSC

#ifdef _LINUX_PLAT
#ifdef _UNICODE_TABLE
#include <dirent.h>
#include <stdio.h>
extern FILE* wfopen(wchar_t* a, wchar_t* bb);
extern DIR* wopendir(wchar_t* a);
extern int wsetenv(wchar_t* a, wchar_t* b, int c);
extern int wgetenv(wchar_t* a, int flag, wchar_t* b);
extern int wsystem(wchar_t* a);
#endif  //_UNICODE_TABLE
#define wfopen   wfopen
#define wopendir wopendir
#define wsetenv  wsetenv
#define wsystem  wsystem
#endif  //_LINUX_PLAT

#ifdef _UNICODE_TABLE
#define UNICHAR wchar_t
#define MTRLEN(a)        wcslen(a)
#define MTRCMP(a, b)     wcscmp(a, b)
#define MTRNCMP(a, b, c) wcsncmp(a, b, c)
#else  //_UNICODE_TABLE
#define UNICHAR char
#define MTRLEN(a)        strlen(a)
#define MTRCMP(a, b)     strcmp(a, b)
#define MTRNCMP(a, b, c) strncmp(a, b, c)
#endif  //_UNICODE_TABLE

#ifdef _LINUX_PLAT
#ifdef _UNICODE_TABLE
#define SEP_S (wchar_t *)L"/"
#define SEP_C (wchar_t)L'/'
#else  //_UNICODE_TABLE
#define SEP_S "/"
#define SEP_C '/'
#endif  //_UNICODE_TABLE
#else  //_LINUX_PLAT
#ifdef _UNICODE_TABLE
#define SEP_S (wchar_t *)L"\\"
#define SEP_C (wchar_t)L'\\'
#else  //_UNICODE_TABLE
#define SEP_S "\\"
#define SEP_C '\\'
#endif  //_UNICODE_TABLE
#endif  //_LINUX_PLAT

#ifdef _UNICODE_TABLE
#define LIT_SINGLE_S (wchar_t*)L"\'"
#define LIT_NULL_S   (wchar_t*)L""
#define LIT_BLANK_S  (wchar_t*)L" "
#define LIT_NULL_C   L'\0'
#define LIT_TAB_C    L'\t'
#define LIT_HTML5_C  L'5'
#define LIT_BLANC_C  L' '
#define INI_ON       (wchar_t*)L"ON"
#define INI_OFF      (wchar_t*)L"OFF"
#else  //_UNICODE_TABLE
#define LIT_SINGLE_S "\'"
#define LIT_NULL_S   ""
#define LIT_BLANK_S  " "
#define LIT_NULL_C   '\0'
#define LIT_TAB_C    '\t'
#define LIT_HTML5_C  '5'
#define LIT_BLANC_C  ' '
#define INI_ON       "ON"
#define INI_OFF      "OFF"
#endif  //_UNICODE_TABLE

//シフトJIS 先頭1バイト
#define LIT_H81 0xffffff81
#define LIT_H9F 0xffffff9f
#define LIT_HE0 0xffffffe0
#define LIT_HFC 0xfffffffc

//EUC 先頭1バイト
#define LIT_H8E	0xffffff8e
#define LIT_HA1	0xffffffa1
#define LIT_HFE	0xfffffffe
#define LIT_H8F	0xffffff8f

//半角カナ　UNICODE ff61-ff9f
#define LIT_K61	(UNICHAR)0xffffff61
#define LIT_K9F	(UNICHAR)0xffffff9f

//半角カナ　ASCII最大値
#define LIT_KFF	255

//改行
#define LIT_HCR	0x0d
#define LIT_HLF	0x0a


//rdbファイル名
#ifdef _SDK
#define LIT_RDB_FILEA "CalcSDK.rdb"
#ifdef _UNICODE_TABLE
#define LIT_RDB_FILEW (wchar_t *)L"CalcSDK.rdb"
#else  //_UNICODE_TABLE
#define LIT_RDB_FILEW  LIT_RDB_FILEA
#endif  //_UNICODE_TABLE
#endif  //_SDK

//iniファイル名
#ifdef _UNICODE_TABLE
#ifdef _WIKI
#define INIFILE (wchar_t *)L"CtoWiki.ini"
#elif _HTML
#define INIFILE (wchar_t *)L"CtoHtml.ini"
#else  //_JPN _ENG
#define INIFILE (wchar_t *)L"CtoMail.ini"
#endif  //_JPN _ENG
#else  //_UNICODE_TABLE
#ifdef _WIKI
#define INIFILE "CtoWiki.ini"
#elif _HTML
#define INIFILE "CtoHtml.ini"
#else  //_JPN _ENG
#define INIFILE "CtoMail.ini"
#endif  //_JPN _ENG
#endif  //_UNICODE_TABLE

#define FILENAME_SIZE 1024

//------------------------------------------------------------------------------
//構造体定義
//------------------------------------------------------------------------------
//長さ付き文字列
typedef struct {
	int  size;
#ifdef _UNICODE_TABLE
	wchar_t *data;//文字列が格納できるバイト数(実際に確保された領域-1バイト)
#else  //_UNICODE_TABLE
	char *data;//文字列が格納できるバイト数(実際に確保された領域-1バイト)
#endif  //_UNICODE_TABLE
} CHAR_LEN;

typedef struct cell {
	CHAR_LEN text;     //文字列（取り込み）
//	int type;          //セルの文字の属性（取り込み）
	int line[4];       //線の太さ（取り込み）
	long h_ichi;       //セル内の横文字位置（取り込み）
	long v_ichi;       //セル内の縦文字位置（取り込み）
#if defined(_JPN) || defined(_ENG)
	int charno;        //セルの枠内の文字を矩形にしたときの文字数（計算）
	int charpos;       //セルの枠内の編集済み文字位置（計算　作業用）
	int linepos;       //セルの枠内の編集済み行数（計算　作業用）
	int haba;          //セル内の罫線の数（計算）
	int takasa;        //セル内の列数（計算）
#endif  //_JPN _ENG
	int num_flag;      // =1数字のみ =0他の文字あり（計算）
	int merge[8];      //[0]=Left [1]=Right [2]=Top [3]=Bottom [4]=Flag [5]=Width [6]=Height [7]=Base
	                   //Flag=0 マージなし !=0 マージあり   12223　マージされた枠の
	                   //                                   45556　どの部分であるか
	                   //                                   78889　5は、枠線無し
#if defined(_WIKI) || defined(_HTML)
	unsigned int fcolor;    //文字色
	int size;               //文字の大きさ
	bool bold;              //太字
	bool italic;            //斜体
	int underline;          //下線
	int strikethrough;      //取り消し線
	unsigned int bcolor;    //背景色
	unsigned int lcolor[4]; //罫線の色
#endif  //_WIKI _HTML
} CELL;

typedef struct pos {
	int posp;		//枠の開始位置
	int posw;		//枠の幅(高さ)
} POS;

//------------------------------------------------------------------------------
//関数定義
//------------------------------------------------------------------------------
extern void CalcCntl();
extern int CalcGet();
extern int CalcAcc();
extern int CalcEnd(int flag);
extern int MakeData();
extern int HalfCheck(UNICHAR *indata, int sa, int ea);
extern int AllocArea();
extern void FreeArea();
extern int ByteChk(UNICHAR ch);
extern int DataDivision(UNICHAR *indata);
extern int ClipWrite(UNICHAR *wkdata);
extern int ClipRead(UNICHAR **wkdata);
extern int ClipCheck();
extern int ProfileGet(UNICHAR *Inifile);
extern unsigned int FileSizeGet(UNICHAR *path_name, UNICHAR *file_name);
extern int ProgressView(int par);
extern int MessageDisp(int no);
extern void TimeOut(char *);
#ifdef _SDK
extern int Soffice_Path_get();
extern int RdbCheck();
extern void EnvSet();
extern int ServerRun(UNICHAR *param);
#endif  //_SDK
#ifdef _OLE
extern int AutoWrap(HRESULT *hr, int aType, VARIANT *Res, IDispatch *pDisp, LPOLESTR ptName, int cArgs, ...);
#endif  //_OLE
#ifdef _LINUX_PLAT
extern int Window_Refresh();
#endif  //_LINUX_PLAT
extern int GetProfileWrapp(int flag, UNICHAR *filename, UNICHAR *section, UNICHAR *key, UNICHAR *def, UNICHAR *data, int len);
extern int CharLenNewAlloc(CHAR_LEN *char_len, int size);
extern int CharLenReAlloc(CHAR_LEN *char_len, int addsize);
extern int CharLenCat(CHAR_LEN *char_len, UNICHAR *add);
extern int CharLenNCat(CHAR_LEN *char_len, UNICHAR *add, int len);
extern int CharLenFree(CHAR_LEN *char_len);

//------------------------------------------------------------------------------
//変数定義
//------------------------------------------------------------------------------
extern UNICHAR AppPath[FILENAME_SIZE];
extern UNICHAR Inifile[FILENAME_SIZE];

extern CELL *hyo;
#if defined(_JPN) || defined(_ENG)
extern POS *yoko_p;
extern POS *tate_p;
#endif  //_JPN _ENG
extern CHAR_LEN out_data;
extern CHAR_LEN out_wk_data;
extern UNICHAR *clip_data;
extern int *font_attr;
extern int *cell_attr;

extern int Col_no, Row_no, Break_flag, Allline_flag;
extern int Area_pos, Proc_pos, Use_pos, Use_flag[10], Out_alloc, Out_wk_alloc, Clip_alloc;
extern int font_attr_maxno, font_attr_no, font_attr_alloc;
extern int cell_attr_maxno, cell_attr_no, cell_attr_alloc;
extern int text_flag;

extern UNICHAR OfficeInstPath[FILENAME_SIZE], //Officeがインストールされたパス
               SofficePath[FILENAME_SIZE],    //sofficeのパス
               SofficeRdbPath[FILENAME_SIZE], //offapi.rdbファイルのパス
               SofficeVersion[100],           //バージョン
               SofficeCommand[1000];          //サーバプロセス起動コマンド
extern int Verno;

#ifdef _WINDOWS_PLAT
extern HWND hWnd;
#endif  //_WINDOWS_PLAT

//パラメータ入力の変数
extern int ClipWaitCount, ClipWaitTime, TimeLog, AsciiWide, HoriWide;
#ifdef _UNICODE_TABLE
extern wchar_t Locale[500];
#endif  //_UNICODE_TABLE
extern UNICHAR Evasion[50];
extern int Tmin, Tsec;

#define KEY_SIZE   101
#define CHENGE_MAX 5

//入力パラメーター
typedef struct {
	int     it[5];
	UNICHAR dt[KEY_SIZE];
} IN_PARM;

#ifdef _WIKI
extern UNICHAR In_cntl_char[10];
extern IN_PARM In_line_color_wik, In_line_width_wik, In_back_color_wik, In_font_color_wik, In_font_size_wik;
extern IN_PARM In_font_bold_wik, In_font_underline_wik, In_font_italic_wik, In_font_strikethrough_wik;
extern IN_PARM In_cell_poshr_wik, In_cell_poshc_wik, In_cell_poshl_wik, In_cell_posvt_wik, In_cell_posvc_wik, In_cell_posvb_wik, In_cell_sep_wik, In_cell_mrgh_wik;
extern IN_PARM In_cell_mrgv_wik, In_code_chenge_m_wik[CHENGE_MAX], In_code_chenge_o_wik[CHENGE_MAX], In_code_chenge_r_wik[CHENGE_MAX];
extern int In_code_chenge_no;
#endif  //_WIKI

#ifdef _HTML
extern UNICHAR In_html_version[KEY_SIZE];
extern IN_PARM In_table_posh, In_table_outline, In_line_color_yn, In_line_width_yn, In_back_color_yn;
extern IN_PARM In_font_color_yn, In_font_size_yn, In_font_bold_yn, In_font_underline_yn;
extern IN_PARM In_font_italic_yn, In_font_strikethrough_yn, In_cell_posh_yn, In_cell_posv_yn;
#endif  //_HTML

#ifdef _WINDOWS_PLAT
extern _CRTIMP int __cdecl SPRINTF(UNICHAR * a, int len, const UNICHAR *c, ...);
#else  //_WINDOWS_PLAT
#ifdef _UNICODE_TABLE
#define SPRINTF swprintf
#else  //_UNICODE_TABLE
#define SPRINTF sprintf
#endif  //_UNICODE_TABLE
#endif  //_WINDOWS_PLAT


