﻿//*****************************************************************************
//* Copyright (c) 2011-2012 Miday Workshop All rights reserved.
//*
//* File: CalcOle.cpp
//*****************************************************************************

//==========================　定義　あると表示
//#define _TEST_VIEW
//==========================

#ifdef _OLE
#include <windows.h>
#include <new>
#include <stdlib.h>
#include <stdio.h>
#include <ole2.h>
#include "CalcDef.h"
#include "MsgLocale.h"

#define USE_CONTROLLER   0
#define USE_ACTIVESHEET  1
#define USE_CURRENTPOS1  2
#define USE_CURRENTPOS2  3
#define USE_CELL         4
#define USE_WORK1        5
#define USE_WORK2        6
#define USE_CURSOR       7
#define USE_RANGEADDRESS 8

IDispatch *pobjServiceManager;
VARIANT ClStardesktop, ClDispValue, ClDoc, ClSheets, ClFrame, ClHelper, ClArea;
VARIANT ClController, ClActiveSheet, ClCurrentPos1, ClCurrentPos2, ClCell, ClWork1, ClWork2, ClCursor, ClRangeAddress;

//CLSID
CLSID clsid;
HRESULT hr;

#define NOTEST     0
#define TEST       1

//                     AR_LEFT        AR_RIGHT        AR_TOP        AR_BOTTOM
wchar_t *brdside[] = { L"LeftBorder", L"RightBorder", L"TopBorder", L"BottomBorder" };
//                     AR_LEFT         AR_RIGH       AR_TOP       AR_BOTTOM
wchar_t *mrgside[] = { L"StartColumn", L"EndColumn", L"StartRow", L"EndRow" };

//==============================================================================
//Calcの終了処理
//==============================================================================
int CalcEnd(int flag) {
//以下は原則
//OLE エラー　　　　　　　　AutoWrapから呼ばれる(flag=0)
//その他のエラー　　　　　　このファイルから呼ばれる(flag=1)
//------------------------------------------------------------------------------
//シートクローズ
//------------------------------------------------------------------------------
	if ( flag == 1 ){
#ifndef _TEST_VIEW
			if ( Use_pos >= 4 ) {
				if ( AutoWrap(&hr, DISPATCH_METHOD, NULL, ClDoc.pdispVal, L"Close", 1, FALSE) != 0 ) return OLE_ERROR;
			}
#endif  //_TEST_VIEW
	}

//------------------------------------------------------------------------------
//領域開放
//------------------------------------------------------------------------------
	if ( Use_flag[USE_CONTROLLER] == 1 ) {
		VariantClear(&ClController);
		Use_flag[USE_CONTROLLER] = 0;
	}
	if ( Use_flag[USE_ACTIVESHEET] == 1 ) {
		VariantClear(&ClActiveSheet);
		Use_flag[USE_ACTIVESHEET] = 0;
	}
	if ( Use_flag[USE_CURRENTPOS1] == 1 ) {
		VariantClear(&ClCurrentPos1);
		Use_flag[USE_CURRENTPOS1] = 0;
	}
	if ( Use_flag[USE_CURRENTPOS2] == 1 ) {
		VariantClear(&ClCurrentPos2);
		Use_flag[USE_CURRENTPOS2] = 0;
	}
	if ( Use_flag[USE_CELL] == 1 ) {
		VariantClear(&ClCell);
		Use_flag[USE_CELL] = 0;
	}
	if ( Use_flag[USE_WORK1] == 1 ) {
		VariantClear(&ClWork1);
		Use_flag[USE_WORK1] = 0;
	}
	if ( Use_flag[USE_WORK2] == 1 ) {
		VariantClear(&ClWork2);
		Use_flag[USE_WORK2] = 0;
	}
	if ( Use_flag[USE_CURSOR] == 1 ) {
		VariantClear(&ClCursor);
		Use_flag[USE_CURSOR] = 0;
	}
	if ( Use_flag[USE_RANGEADDRESS] == 1 ) {
		VariantClear(&ClRangeAddress);
		Use_flag[USE_RANGEADDRESS] = 0;
	}

	switch(Use_pos) {
	case 8:
		VariantClear(&ClArea);
	case 7:
		VariantClear(&ClHelper);
	case 6:
		VariantClear(&ClFrame);
	case 5:
		VariantClear(&ClSheets);
	case 4:
		VariantClear(&ClDoc);
	case 3:
		VariantClear(&ClDispValue);
	case 2:
		VariantClear(&ClStardesktop);
	case 1:
		pobjServiceManager->Release();
	}
	Use_pos  = 0;

//------------------------------------------------------------------------------
//このスレッドのCOMを初期化を解除
//------------------------------------------------------------------------------
	CoUninitialize();

	return NOMAL_RETURN;
}

//==============================================================================
//Calcを起動し、セルの情報を取り込む
//==============================================================================
int CalcAcc() {

	VARIANT Args;
	VARIANT parm[4];
	VARIANT parm_ary;

	SAFEARRAY *propVal;
	long idx;

	int iw, ih, iw2, ih2, ix, ii, io, ib, irc;
	int mrg_wk[4];
	int sabun;
	int col, row;
#if !defined(_MSC_VER) || _MSC_VER < 1400
	int sizew;
#else  //MSC
	size_t sizew;
#endif  //MSC
#ifndef _UNICODE_TABLE
#if !defined(_MSC_VER) || _MSC_VER < 1400
	int sizew2;
#else  //MSC
	size_t sizew2;
#endif  //MSC
#endif  //_UNICODE_TABLE

	Area_pos         = 0;
	Use_pos          = 0;
	for(ib=0; ib<sizeof(Use_flag)/4; ib++) {
		Use_flag[ib]          = 0;
	}
	Out_alloc        = 0;
	Out_wk_alloc     = 0;
	Clip_alloc       = 0;
	font_attr_alloc  = 0;
	cell_attr_alloc  = 0;
	col              = 0;
	row              = 0;

	if ( Break_flag == 1 ) {
		irc = MessageDisp( MSG_CANCLE_CODE );
		Break_flag = 2;
		return CANCEL_RETURN;
	}

	//クリップボードを調べデータ分の枠を作る
	text_flag = ClipCheck();
	if ( text_flag == IN_NOTDATA ) {
		return FINISHING_MESSAGE;
	}

	if ( text_flag == IN_TEXTDATA || text_flag == IN_UNIDATA ) {
		if ( MessageDisp( MSG_ALL_LINE_CODE ) != IDOK ) {
			irc = MessageDisp( MSG_CANCLE_CODE );
			return CANCEL_RETURN;
		} else {
			Allline_flag = 1;
		}

		if ( ClipRead( &clip_data ) != NOMAL_RETURN ) {
			FreeArea();
			return FINISHING_MESSAGE;
		}
		Clip_alloc = 1;

		//クリップボードのデータを分割する
		if ( DataDivision(clip_data) != 0 ) {//メモリ確保エラー
			FreeArea();
			return MEMORY_ERROR;
		}

		ProgressView(90);
		return NOMAL_RETURN;//エリアは開放しない
	}

//------------------------------------------------------------------------------
//COM初期化
//------------------------------------------------------------------------------
	Proc_pos = 0;
	CoInitialize(NULL);

//------------------------------------------------------------------------------
//CLSID取得
//------------------------------------------------------------------------------
	Proc_pos = 1;
	hr = CLSIDFromProgID(L"com.sun.star.ServiceManager", &clsid);
	ProgressView(5);

	if(FAILED(hr)) {
		return OLE_ERROR;
	}

//------------------------------------------------------------------------------
//サーバーを開始し、IDispatchを取り出す
//------------------------------------------------------------------------------
	Proc_pos = 2;
//	hr = CoCreateInstance(&clsid, NULL, CLSCTX_LOCAL_SERVER, &IID_IDispatch, (void **)&pobjServiceManager);
	hr = CoCreateInstance(clsid, NULL, CLSCTX_LOCAL_SERVER, IID_IDispatch, (void **)&pobjServiceManager);
	if(FAILED(hr)) {
		return OLE_ERROR;
	}
	Use_pos = 1;

//------------------------------------------------------------------------------
//デスクトップとassocを取り出す
//------------------------------------------------------------------------------
	Proc_pos = 3;
	{
		VARIANT parmdesktop;
		VariantInit(&ClStardesktop);
		VariantInit(&parmdesktop);
		parmdesktop.vt = VT_BSTR;
		parmdesktop.bstrVal = SysAllocString( L"com.sun.star.frame.Desktop");
		if ( AutoWrap(&hr, DISPATCH_METHOD, &ClStardesktop, pobjServiceManager, L"createInstance", 1, parmdesktop) != 0 ) {
			VariantClear(&parmdesktop);
			VariantClear(&ClStardesktop);
			return OLE_ERROR;
		}
		VariantClear(&parmdesktop);
//		VariantClear(&ClStardesktop);
		Use_pos = 2;
	}

	{
		VariantInit(&ClDispValue);
		VariantInit(&parm[0]);
		parm[0].vt = VT_BSTR;
		parm[0].bstrVal = SysAllocString(L"com.sun.star.beans.PropertyValue");
		if ( AutoWrap(&hr, DISPATCH_PROPERTYGET|DISPATCH_METHOD, &ClDispValue, pobjServiceManager, L"Bridge_GetStruct", 1, parm[0]) != 0 ) {
			VariantClear(&parm[0]);
			VariantClear(&ClDispValue);
			return OLE_ERROR;
		}
		VariantClear(&parm[0]);
//		VariantClear(&ClDispValue);
		Use_pos = 3;
	}

//------------------------------------------------------------------------------
//テスト用に表示する
//------------------------------------------------------------------------------
#ifndef _TEST_VIEW
		//本番用に非表示
		{
			//NameとValueを設定
			VariantInit(&parm[0]);
			parm[0].vt      = VT_BSTR;
			parm[0].bstrVal = SysAllocString(L"Hidden");
			if ( AutoWrap(&hr, DISPATCH_PROPERTYPUT, NULL, ClDispValue.pdispVal, L"Name", 1, parm[0]) != 0 ) {
				VariantClear(&parm[0]);
				return OLE_ERROR;
			}
			VariantClear(&parm[0]);
		}

		{
			VariantInit(&parm[0]);
			parm[0].vt      = VT_BOOL;
			parm[0].boolVal = (short)0xFFFF;//TRUE;
			if ( AutoWrap(&hr, DISPATCH_PROPERTYPUT, NULL, ClDispValue.pdispVal, L"Value", 1, parm[0]) != 0 ) {
				VariantClear(&parm[0]);
				return OLE_ERROR;
			}
			VariantClear(&parm[0]);
		}

		VariantInit(&Args);
		Args.vt       = VT_DISPATCH;
		Args.pdispVal = ClDispValue.pdispVal;

		propVal = SafeArrayCreateVector(VT_VARIANT, 0, 1);
		idx = 0;
		SafeArrayPutElement(propVal, &idx, &Args);
//		VariantClear(&Args);//ClDispValue.pdispValの領域なのでクリアしない
#else  //_TEST_VIEW
		//テスト用に表示
		propVal = SafeArrayCreateVector(VT_VARIANT, 0, 0);
#endif  //_TEST_VIEW

//------------------------------------------------------------------------------
//新しい文書を開く
//------------------------------------------------------------------------------
	VariantInit(&parm[0]);
	parm[0].vt = VT_BSTR;
	parm[0].bstrVal = SysAllocString(L"private:factory/scalc");

	VariantInit(&parm[1]);
	parm[1].vt = VT_BSTR;
	parm[1].bstrVal = SysAllocString(L"_blank");

	VariantInit(&parm[2]);
	parm[2].vt = VT_I4;
	parm[2].lVal = 0;

	VariantInit(&parm_ary);
	parm_ary.vt = VT_ARRAY | VT_VARIANT;
	parm_ary.parray = propVal;

	{
		VariantInit(&ClDoc);
		if ( AutoWrap(&hr, DISPATCH_METHOD, &ClDoc, ClStardesktop.pdispVal, L"loadComponentFromURL", 4, parm_ary, parm[2], parm[1], parm[0]) != 0 ) {
			VariantClear(&ClDoc);
//			VariantClear(&parm_ary);//クリアしない
			VariantClear(&parm[2]);
			VariantClear(&parm[1]);
			VariantClear(&parm[0]);
			SafeArrayDestroyDescriptor(propVal);
			return OLE_ERROR;
		}
//		VariantClear(&ClDoc);
		Use_pos = 4;
	}

//	VariantClear(&parm_ary);//クリアしない
	VariantClear(&parm[2]);
	VariantClear(&parm[1]);
	VariantClear(&parm[0]);
	SafeArrayDestroyDescriptor(propVal);

	{
		VariantInit(&ClSheets);
		if ( AutoWrap(&hr, DISPATCH_PROPERTYGET|DISPATCH_METHOD, &ClSheets, ClDoc.pdispVal, L"sheets", 0) != 0 ) {
			VariantClear(&ClSheets);
			return OLE_ERROR;
		}
//		VariantClear(&ClSheets);
		Use_pos = 5;
	}

	VariantInit(&ClController);
	Use_flag[USE_CONTROLLER] = 1;
	if ( AutoWrap(&hr, DISPATCH_PROPERTYGET|DISPATCH_METHOD, &ClController, ClDoc.pdispVal, L"getCurrentController", 0) != 0 ) {
		VariantClear(&ClController);
		Use_flag[USE_CONTROLLER] = 0;
		return OLE_ERROR;
	}
//	VariantClear(&ClController);後ろで実行
//	Use_flag[USE_CONTROLLER] = 0;

	{
		VariantInit(&ClFrame);
		if ( AutoWrap(&hr, DISPATCH_PROPERTYGET|DISPATCH_METHOD, &ClFrame, ClController.pdispVal, L"getFrame", 0) != 0 ) {
			VariantClear(&ClFrame);
			return OLE_ERROR;
		}
//		VariantClear(&ClFrame);
		Use_pos = 6;
	}

	{
		VariantInit(&ClActiveSheet);
		Use_flag[USE_ACTIVESHEET] = 1;
		if ( AutoWrap(&hr, DISPATCH_PROPERTYGET|DISPATCH_METHOD, &ClActiveSheet, ClController.pdispVal, L"getActiveSheet", 0) != 0 ) {
			VariantClear(&ClActiveSheet);
			Use_flag[USE_ACTIVESHEET] = 0;
			return OLE_ERROR;
		}
		VariantClear(&ClActiveSheet);
		Use_flag[USE_ACTIVESHEET] = 0;
	}
	VariantClear(&ClController);
	Use_flag[USE_CONTROLLER] = 0;

	{
		VariantInit(&parm[0]);
		VariantInit(&ClHelper);
		parm[0].vt = VT_BSTR;
		parm[0].bstrVal = SysAllocString(L"com.sun.star.frame.DispatchHelper");
		if ( AutoWrap(&hr, DISPATCH_PROPERTYGET|DISPATCH_METHOD, &ClHelper, pobjServiceManager, L"createInstance", 1, parm[0]) != 0 ) {
			VariantClear(&ClHelper);
			VariantClear(&parm[0]);
			return OLE_ERROR;
		}
//		VariantClear(&ClHelper);
		VariantClear(&parm[0]);
		Use_pos = 7;
	}

//------------------------------------------------------------------------------
//A1のセルに移動
//------------------------------------------------------------------------------
	VariantInit(&parm[0]);
	parm[0].vt = VT_BSTR;
	parm[0].bstrVal = SysAllocString(L"ToPoint");
	if ( AutoWrap(&hr, DISPATCH_PROPERTYPUT, NULL, ClDispValue.pdispVal, L"Name", 1, parm[0]) != 0 ) {
		VariantClear(&parm[0]);
		return OLE_ERROR;
	}
	VariantClear(&parm[0]);

	VariantInit(&parm[0]);
	parm[0].vt = VT_BSTR;
	parm[0].bstrVal = SysAllocString(L"$A$1");
	if ( AutoWrap(&hr, DISPATCH_PROPERTYPUT, NULL, ClDispValue.pdispVal, L"Value", 1, parm[0]) != 0 ) {
		VariantClear(&parm[0]);
		return OLE_ERROR;
	}
	VariantClear(&parm[0]);

	propVal = SafeArrayCreateVector (VT_DISPATCH, 0, 1);
	idx = 0;
	SafeArrayPutElement (propVal, &idx, ClDispValue.pdispVal);

	VariantInit(&parm[1]);
	parm[1].vt = VT_BSTR;
	parm[1].bstrVal = SysAllocString(L".uno:GoToCell");

	VariantInit(&parm[2]);
	parm[2].vt = VT_BSTR;
	parm[2].bstrVal = SysAllocString(L"");

	VariantInit(&parm[3]);
	parm[3].vt = VT_I4;
	parm[3].lVal = 0;

	VariantInit(&parm_ary);
	parm_ary.vt = VT_ARRAY | VT_DISPATCH;
	parm_ary.parray = propVal;

	if ( AutoWrap(&hr, DISPATCH_METHOD, NULL, ClHelper.pdispVal, L"executeDispatch",
				5, parm_ary, parm[3], parm[2], parm[1], ClFrame) != 0 ) {
		VariantClear(&parm[3]);
		VariantClear(&parm[2]);
		VariantClear(&parm[1]);
//		VariantClear(&parm_ary);//クリアしない
		SafeArrayDestroyDescriptor(propVal);
		return OLE_ERROR;
	}

//	VariantClear(&parm[3]);//次のステップで使用
//	VariantClear(&parm[2]);//次のステップで使用
	VariantClear(&parm[1]);
//	VariantClear(&parm_ary);//クリアしない
	SafeArrayDestroyDescriptor(propVal);

//------------------------------------------------------------------------------
//クリップボードからペースト
//------------------------------------------------------------------------------
	Proc_pos = 4;
	VariantInit(&parm[0]);
	parm[0].vt = VT_BSTR;
	parm[0].bstrVal = SysAllocString(L"Flags");
	if ( AutoWrap(&hr, DISPATCH_PROPERTYPUT, NULL, ClDispValue.pdispVal, L"Name", 1, parm[0]) != 0 ) {
		VariantClear(&parm[0]);
		return OLE_ERROR;
	}
	VariantClear(&parm[0]);

	VariantInit(&parm[0]);
	parm[0].vt = VT_BSTR;
	parm[0].bstrVal = SysAllocString(L"SVDNT");
//parm[0].bstrVal = SysAllocString(L"SVD");
	if ( AutoWrap(&hr, DISPATCH_PROPERTYPUT, NULL, ClDispValue.pdispVal, L"Value", 1, parm[0]) != 0 ) {
		VariantClear(&parm[0]);
		return OLE_ERROR;
	}
	VariantClear(&parm[0]);

	propVal = SafeArrayCreateVector (VT_DISPATCH, 0, 1);
	idx = 0;
	SafeArrayPutElement (propVal, &idx, ClDispValue.pdispVal);

	VariantInit(&parm[1]);
	parm[1].vt = VT_BSTR;
	//元のデータがテキストの処理を廃止したため、".uno:Paste"のみにする　
	//画面を表示していてセルが1つのテキストデータは .uno:Paste 可能
	//セルが複数のテキストデータは問い合わせ画面があるので .uno:InsertContents とする
//	if ( Test_flag == TEST && col == 1 && row == 1 ) {
//		parm[1].bstrVal = SysAllocString(L".uno:Paste");
//	} else {
//		parm[1].bstrVal = SysAllocString(L".uno:InsertContents");
//	}

//#ifdef _TEST_VIEW
//	if ( col == 1 && row == 1 ) {
//		parm[1].bstrVal = SysAllocString(L".uno:Paste");
//	} else {
//		parm[1].bstrVal = SysAllocString(L".uno:InsertContents");
//	}
//#else  //_TEST_VIEW
//		parm[1].bstrVal = SysAllocString(L".uno:InsertContents");
//#endif  //_TEST_VIEW
		parm[1].bstrVal = SysAllocString(L".uno:Paste");



//	VariantInit(&parm[2]);
//	parm[2].vt = VT_BSTR;
//	parm[2].bstrVal = SysAllocString(LIT_NULL_S);//L""

//	VariantInit(&parm[3]);
//	parm[3].vt = VT_I4;
//	parm[3].lVal = 0;

	VariantInit(&parm_ary);
	parm_ary.vt = VT_ARRAY | VT_DISPATCH;
	parm_ary.parray = propVal;
	if ( AutoWrap(&hr, DISPATCH_METHOD, NULL, ClHelper.pdispVal, L"executeDispatch",
				5, parm_ary, parm[3], parm[2], parm[1], ClFrame) != 0 ) {
		VariantClear(&parm[3]);
		VariantClear(&parm[2]);
		VariantClear(&parm[1]);
//		VariantClear(&parm_ary);//クリアしない
		SafeArrayDestroyDescriptor(propVal);
		return OLE_ERROR;
	}

	VariantClear(&parm[3]);
	VariantClear(&parm[2]);
	VariantClear(&parm[1]);
//	VariantClear(&parm_ary);//クリアしない
	SafeArrayDestroyDescriptor(propVal);

	ProgressView(15);

//------------------------------------------------------------------------------
//選択範囲を調べる
//------------------------------------------------------------------------------
	Proc_pos = 5;
	Col_no = 0;
	Row_no = 0;
	{
		VariantInit(&ClArea);
		if ( AutoWrap(&hr, DISPATCH_PROPERTYGET|DISPATCH_METHOD, &ClArea, ClDoc.pdispVal, L"CurrentSelection", 0) != 0 ) {
			VariantClear(&ClArea);
			return OLE_ERROR;
		}
//		VariantClear(&ClArea);
		Use_pos = 8;
	}

	{
		VariantInit(&ClCurrentPos1);
		Use_flag[USE_CURRENTPOS1] = 1;
		irc = AutoWrap(&hr, DISPATCH_PROPERTYGET|DISPATCH_METHOD, &ClCurrentPos1, ClArea.pdispVal, L"Columns", 0);

		//貼り付けに失敗した(Calcのデータではないと思われる)
		if ( irc == MSG_ER_APP_CODE ) {
			if ( MessageDisp( MSG_ER_APP_CODE ) != IDOK ) {
				irc = MessageDisp( MSG_CANCLE_CODE );
				VariantClear(&ClCurrentPos1);
				Use_flag[USE_CURRENTPOS1] = 0;
				irc = CalcEnd(1);
				FreeArea();
				return CANCEL_RETURN;
			} else {
				//クリップボードから直接読み込む
				Allline_flag = 1;
				VariantClear(&ClCurrentPos1);
				Use_flag[USE_CURRENTPOS1] = 0;

				if ( ClipRead( &clip_data ) != NOMAL_RETURN ) {
					FreeArea();
					return FINISHING_MESSAGE;
				}
				Clip_alloc = 1;

				//クリップボードのデータを分割する
				if ( DataDivision(clip_data) != 0 ) {//メモリ確保エラー
					FreeArea();
					return MEMORY_ERROR;
				}

				ProgressView(90);
				return NOMAL_RETURN;//エリアは開放しない
			}
		}
		if ( irc != 0 ) {
			VariantClear(&ClCurrentPos1);
			Use_flag[USE_CURRENTPOS1] = 0;
			return OLE_ERROR;
		}
//		VariantClear(&ClCurrentPos1);//後ろでクリア
//		Use_flag[USE_CURRENTPOS1] = 0;
	}

	{
		VARIANT result;
		VariantInit(&result);
		if ( AutoWrap(&hr, DISPATCH_PROPERTYGET|DISPATCH_METHOD, &result, ClCurrentPos1.pdispVal, L"getCount", 0) != 0 ) {
			VariantClear(&result);
			return OLE_ERROR;
		}
//char testdata[100];
//SPRINTF(testdata, sizeof(testdata), "col %d=%d %x ", result.vt, VT_I4, result.lVal);
//MessageBox( hWnd, testdata, "", 0);
		Col_no = (int)result.lVal;
		VariantClear(&result);
	}

	{
		VariantInit(&ClCurrentPos2);
		Use_flag[USE_CURRENTPOS2] = 1;
		if ( AutoWrap(&hr, DISPATCH_PROPERTYGET|DISPATCH_METHOD, &ClCurrentPos2, ClArea.pdispVal, L"Rows", 0) != 0 ) {
			VariantClear(&ClCurrentPos2);
			Use_flag[USE_CURRENTPOS2] = 0;
			return OLE_ERROR;
		}
//		VariantClear(&ClCurrentPos2);//後ろでクリア
//		Use_flag[USE_CURRENTPOS2] = 0;
	}

	{
		VARIANT result;
		VariantInit(&result);
		if ( AutoWrap(&hr, DISPATCH_PROPERTYGET|DISPATCH_METHOD, &result, ClCurrentPos2.pdispVal, L"getCount", 0) != 0 ) {
			VariantClear(&result);
			return OLE_ERROR;
		}
//char testdata[100];
//SPRINTF(testdata, sizeof(testdata), "row %d=%d %x ", result.vt, VT_I4, result.lVal);
//MessageBox( hWnd, testdata, "", 0);
		Row_no = (int)result.lVal;
		VariantClear(&result);
	}
	VariantClear(&ClCurrentPos2);//使い終わったのでクリア
	Use_flag[USE_CURRENTPOS2] = 0;

	VariantClear(&ClCurrentPos1);//使い終わったのでクリア
	Use_flag[USE_CURRENTPOS1] = 0;
	ProgressView(25);

//------------------------------------------------------------------------------
//領域確保
//------------------------------------------------------------------------------
	if ( Break_flag == 1 ) {
		irc = MessageDisp( MSG_CANCLE_CODE );
		irc = CalcEnd(1);
		FreeArea();
		Break_flag = 2;
		return CANCEL_RETURN;
	}

//	//クリップボードのセルの数とCalcでのセルの数が一致しない場合は、テキストのデータとして処理する
//	if ( Col_no != col || Row_no != row ) {//廃止
//		text_flag = IN_TEXTDATA;
//	}
	//領域確保
	if ( AllocArea() != 0 ) {
		irc = CalcEnd(1);
		FreeArea();
		return MEMORY_ERROR;
	}
	sabun = 60 * 1000 / Row_no;	//60%を分割
	ProgressView(30);

//------------------------------------------------------------------------------
//テスト出力
//　Calcからコピーした場合に結果に反映される
//　テキストのコピーではDataDivision関数で処理するので結果に反映されない
//------------------------------------------------------------------------------
//	VariantInit(&parm[0]);
//	parm[0].vt = VT_BSTR;
//	parm[0].bstrVal = SysAllocString(L"StringName");
//	if ( AutoWrap(&hr, DISPATCH_PROPERTYPUT, NULL, ClDispValue.pdispVal, L"Name", 1, parm[0]) != 0 ) {
//		VariantClear(&parm[0]);
//		return OLE_ERROR;
//	}
//	VariantClear(&parm[0]);

//	VariantInit(&parm[0]);
//	parm[0].vt = VT_BSTR;
//	parm[0].bstrVal = SysAllocString(L"ABCDEF");//Lはunicodeの場合に必要
//	if ( AutoWrap(&hr, DISPATCH_PROPERTYPUT, NULL, ClDispValue.pdispVal, L"Value", 1, parm[0]) != 0 ) {
//		VariantClear(&parm[0]);
//		return OLE_ERROR;
//	}
//	VariantClear(&parm[0]);

//	propVal = SafeArrayCreateVector (VT_DISPATCH, 0, 1);
//	idx = 0;
//	SafeArrayPutElement (propVal, &idx, ClDispValue.pdispVal);

//	VariantInit(&parm[1]);
//	parm[1].vt = VT_BSTR;
//	parm[1].bstrVal = SysAllocString(L".uno:EnterString");

//	VariantInit(&parm[2]);
//	parm[2].vt = VT_BSTR;
//	parm[2].bstrVal = SysAllocString(LIT_NULL_S);//L""

//	VariantInit(&parm[3]);
//	parm[3].vt = VT_I4;
//	parm[3].lVal = 0;

//	VariantInit(&parm_ary);
//	parm_ary.vt = VT_ARRAY | VT_DISPATCH;
//	parm_ary.parray = propVal;

//	if ( AutoWrap(&hr, DISPATCH_METHOD, NULL, ClHelper.pdispVal, L"executeDispatch",
//				5, parm_ary, parm[3], parm[2], parm[1], ClFrame) != 0 ) {
//		VariantClear(&parm[3]);
//		VariantClear(&parm[2]);
//		VariantClear(&parm[1]);
//	//	VariantClear(&parm_ary);//クリアしない
//		SafeArrayDestroyDescriptor(propVal);
//		return OLE_ERROR;
//	}

//	VariantClear(&parm[3]);
//	VariantClear(&parm[2]);
//	VariantClear(&parm[1]);
//	//VariantClear(&parm_ary);//クリアしない
//	SafeArrayDestroyDescriptor(propVal);

//------------------------------------------------------------------------------
//セル位置指定
//------------------------------------------------------------------------------
	if ( Break_flag == 1 ) {
		irc = MessageDisp( MSG_CANCLE_CODE );
		irc = CalcEnd(1);
		FreeArea();
		Break_flag = 2;
		return CANCEL_RETURN;
	}

	for( ih=0; ih<Row_no; ih++ ) {
		for( iw=0; iw<Col_no; iw++ ) {
			VARIANT parmColumn;
			VARIANT parmRow;
			VariantInit(&parmColumn);
			parmColumn.vt = VT_I4;
			parmColumn.lVal = iw;

			VariantInit(&parmRow);
			parmRow.vt = VT_I4;
			parmRow.lVal = ih;

			VariantInit(&ClCell);
			Use_flag[USE_CELL] = 1;
			if ( AutoWrap(&hr, DISPATCH_PROPERTYGET|DISPATCH_METHOD, &ClCell, ClArea.pdispVal, L"getCellByPosition", 2, parmRow, parmColumn) != 0 ) {
				VariantClear(&ClCell);
				Use_flag[USE_CELL] = 0;
				VariantClear(&parmRow);
				VariantClear(&parmColumn);
				return OLE_ERROR;
			}
//			VariantClear(&ClCell);//後で使用するのでクリアしない
//			Use_flag[USE_CELL] = 0;
			VariantClear(&parmRow);
			VariantClear(&parmColumn);

//------------------------------------------------------------------------------
//文字列取り込み
//------------------------------------------------------------------------------
			{
				VARIANT result;
				VariantInit(&result);
				if ( AutoWrap(&hr, DISPATCH_PROPERTYGET|DISPATCH_METHOD, &result, ClCell.pdispVal, L"getString", 0) != 0 ) {
					VariantClear(&result);
					return OLE_ERROR;
				}

#ifdef _UNICODE_TABLE
				sizew = MTRLEN(result.bstrVal);
				if ( CharLenNewAlloc(&hyo[ih*Col_no+iw].text, sizew) == MEMORY_ERROR ) {
					VariantClear(&result);
					irc = CalcEnd(1);
					FreeArea();
					return MEMORY_ERROR;
				}

				MTRNCPY( hyo[ih*Col_no+iw].text.data, hyo[ih*Col_no+iw].text.size+1, result.bstrVal, sizew);
				hyo[ih*Col_no+iw].text.data[sizew] = LIT_NULL_C;
//MessageBoxW(NULL, result.bstrVal, hyo[ih*Col_no+iw].text.data, 0);
#else  //_UNICODE_TABLE
#if !defined(_MSC_VER) || _MSC_VER < 1400
				sizew = wcstombs( NULL, (wchar_t*)result.bstrVal, 0);
#else  //MSC
				wcstombs_s( &sizew, NULL, 0, (wchar_t*)result.bstrVal, 0);
#endif  //MSC
				if ( sizew == -1 ) {
					irc = MessageDisp( MSG_ER_CHAR_CODE );
					VariantClear(&result);
					irc = CalcEnd(1);
					FreeArea();
					return FINISHING_MESSAGE;
				}

				if ( CharLenNewAlloc(&hyo[ih*Col_no+iw].text, sizew) == MEMORY_ERROR ) {
					VariantClear(&result);
					irc = CalcEnd(1);
					FreeArea();
					return MEMORY_ERROR;
				}

				UNICHAR *str;
				try{
					str = new UNICHAR[sizew+1];
				}
				catch (...) {
					VariantClear(&result);
					irc = CalcEnd(1);
					FreeArea();
					return MEMORY_ERROR;
				}
				str[0] = '\0';
#if !defined(_MSC_VER) || _MSC_VER < 1400
				sizew2 = wcstombs( str, (wchar_t*)result.bstrVal, sizew + 1);
#else  //MSC
				wcstombs_s( &sizew2, str, sizew+1, (wchar_t*)result.bstrVal, sizew + 1);
#endif  //MSC
				str[sizew] = LIT_NULL_C;
				MTRCPY( hyo[ih*Col_no+iw].text.data, hyo[ih*Col_no+iw].text.size+1, str);
				delete str;
#endif  //_UNICODE_TABLE
				VariantClear(&result);
			}

//------------------------------------------------------------------------------
//文字位置取り込み
//------------------------------------------------------------------------------
//			{
//				VARIANT result;
//				VariantInit(&result);
//				if ( AutoWrap(&hr, DISPATCH_PROPERTYGET|DISPATCH_METHOD, &result, ClCell.pdispVal, L"getType", 0) != 0 ) {
//					VariantClear(&result);
//					return OLE_ERROR;
//				}
//char testdata[100];
//SPRINTF(testdata, sizeof(testdata), "type %d=%d %x ", result.vt, VT_I4, result.lVal);
//MessageBox( hWnd, testdata, "", 0);
//				hyo[ih*Col_no+iw].type = (int)result.lVal;
//				VariantClear(&result);
//			}
			{
				VARIANT result;
				VariantInit(&result);
				if ( AutoWrap(&hr, DISPATCH_PROPERTYGET|DISPATCH_METHOD, &result, ClCell.pdispVal, L"HoriJustify", 0) != 0 ) {
					VariantClear(&result);
					return OLE_ERROR;
				}
//char testdata[100];
//SPRINTF(testdata, sizeof(testdata), "h_ichi %d=%d %x ", result.vt, VT_I4, result.lVal);
//MessageBox( hWnd, testdata, "", 0);
				hyo[ih*Col_no+iw].h_ichi = (int)result.lVal;
				VariantClear(&result);
			}
//------------------------------------------------------------------------------
//文字位置取り込み
//------------------------------------------------------------------------------
			{
				VARIANT result;
				VariantInit(&result);
				if ( AutoWrap(&hr, DISPATCH_PROPERTYGET|DISPATCH_METHOD, &result, ClCell.pdispVal, L"VertJustify", 0) != 0 ) {
					VariantClear(&result);
					return OLE_ERROR;
				}
//char testdata[100];
//SPRINTF(testdata, sizeof(testdata), "v_ichi %d=%d %x ", result.vt, VT_I4, result.lVal);
//MessageBox( hWnd, testdata, "", 0);
				hyo[ih*Col_no+iw].v_ichi = (int)result.lVal;
				VariantClear(&result);
			}

#if defined(_WIKI) || defined(_HTML)
//------------------------------------------------------------------------------
//セルの文字色の属性取り込み
//------------------------------------------------------------------------------
			{
				VARIANT result;
				VariantInit(&result);
				if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &result, ClCell.pdispVal, L"CharColor", 0) != 0 ) {
					VariantClear(&result);
					return OLE_ERROR;
				}
//char testdata[100];
//SPRINTF(testdata, sizeof(testdata), "Color %d=%d %x ", result.vt, VT_I4, result.lVal);
//MessageBox( hWnd, testdata, "", 0);
				hyo[ih*Col_no+iw].fcolor = (unsigned int)result.lVal;
				if ( hyo[ih*Col_no+iw].fcolor == 0xffffffff ) {//0xffffffff=-1=デフォルト
					hyo[ih*Col_no+iw].fcolor = (unsigned int)0x00000000;//自動なら黒
				}
				VariantClear(&result);
			}

//------------------------------------------------------------------------------
//セルの文字の大きさ取り込み
//------------------------------------------------------------------------------
			{
				VARIANT result;
				VariantInit(&result);
				if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &result, ClCell.pdispVal, L"CharHeight", 0) != 0 ) {
					VariantClear(&result);
					return OLE_ERROR;
				}
//char testdata[100];
//SPRINTF(testdata, sizeof(testdata), "文字の大きさ %d=%d %f ", result.vt, VT_R4, result.fltVal);
//MessageBox( hWnd, testdata, "", 0);
				hyo[ih*Col_no+iw].size = (int)result.fltVal;
				VariantClear(&result);
			}

//------------------------------------------------------------------------------
//セルの太字属性取り込み
//------------------------------------------------------------------------------
			{
				VARIANT result;
				VariantInit(&result);
				//CharWeight = 100.0 ノーマル　150.0 太字
				if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &result, ClCell.pdispVal, L"CharWeight", 0) != 0 ) {
					VariantClear(&result);
					return OLE_ERROR;
				}
//char testdata[100];
//SPRINTF(testdata, sizeof(testdata), "太字 %d=%d %f ", result.vt, VT_R4, result.fltVal);
//MessageBox( hWnd, testdata, "", 0);
				if ( result.fltVal >= FONT_WEIGHT_BOLD ) {
					hyo[ih*Col_no+iw].bold = true;
				} else {
					hyo[ih*Col_no+iw].bold = false;
				}
				VariantClear(&result);
			}

//------------------------------------------------------------------------------
//セルの下線取り込み
//------------------------------------------------------------------------------
			{
				VARIANT result;
				VariantInit(&result);
				if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &result, ClCell.pdispVal, L"CharUnderline", 0) != 0 ) {
					VariantClear(&result);
					return OLE_ERROR;
				}
//char testdata[100];
//SPRINTF(testdata, sizeof(testdata), "下線 %d=%d %d ", result.vt, VT_I2, result.iVal);
//MessageBox( hWnd, testdata, "", 0);
				hyo[ih*Col_no+iw].underline = result.iVal;
				VariantClear(&result);
			}

//------------------------------------------------------------------------------
//セルの取り消し線取り込み
//------------------------------------------------------------------------------
			{
				VARIANT result;
				VariantInit(&result);
				//CharStrikeout = 0 ノーマル　その他 線があり
				if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &result, ClCell.pdispVal, L"CharStrikeout", 0) != 0 ) {
					VariantClear(&result);
					return OLE_ERROR;
				}
//char testdata[100];
//SPRINTF(testdata, sizeof(testdata), "取り消し線 %d=%d %d ", result.vt, VT_I2, result.iVal);
//MessageBox( hWnd, testdata, "", 0);
				hyo[ih*Col_no+iw].strikethrough = result.iVal;
				VariantClear(&result);
			}

//------------------------------------------------------------------------------
//セルの斜体属性取り込み
//------------------------------------------------------------------------------
			{
				VARIANT result;
				VariantInit(&result);
				//CharPosture = 0 ノーマル　2 斜体　
				if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &result, ClCell.pdispVal, L"CharPosture", 0) != 0 ) {
					VariantClear(&result);
					return OLE_ERROR;
				}
//char testdata[100];
//SPRINTF(testdata, sizeof(testdata), "斜体 %d=%d %d ", result.vt, VT_I4, result.lVal);
//MessageBox( hWnd, testdata, "", 0);
				if ( result.lVal == FONT_SLANT_ITALIC ) {//斜体なら
					hyo[ih*Col_no+iw].italic = true;
				} else {
					hyo[ih*Col_no+iw].italic = false;
				}
				VariantClear(&result);
			}

//------------------------------------------------------------------------------
//セルの背景色の属性取り込み
//------------------------------------------------------------------------------
			{
				VARIANT result;
				VariantInit(&result);
				if ( AutoWrap(&hr, DISPATCH_PROPERTYGET, &result, ClCell.pdispVal, L"CellBackColor", 0) != 0 ) {
					VariantClear(&result);
					return OLE_ERROR;
				}
//char testdata[100];// CharBackColor
//SPRINTF(testdata, sizeof(testdata), "背景色 %d=%d %x ", result.vt, VT_I4, result.lVal);
//MessageBox( hWnd, testdata, "", 0);
				hyo[ih*Col_no+iw].bcolor = result.lVal;
				if ( hyo[ih*Col_no+iw].bcolor == 0xffffffff ) {//0xffffffff=-1=デフォルト
					hyo[ih*Col_no+iw].bcolor = (unsigned int)0x00ffffff;//自動なら白
				}
				VariantClear(&result);
			}
#endif  //_WIKI _HTML

			for( ix=0; ix<4; ix++ ) {
//------------------------------------------------------------------------------
//セルの線のインスタンス取り込み
//------------------------------------------------------------------------------
				{
					VariantInit(&ClWork1);
					Use_flag[USE_WORK1] = 1;
#ifdef _UNICODE_TABLE
					if ( AutoWrap(&hr, DISPATCH_PROPERTYGET|DISPATCH_METHOD, &ClWork1, ClCell.pdispVal, brdside[ix], 0) != 0 ) {
#else  //_UNICODE_TABLE
					if ( AutoWrap(&hr, DISPATCH_PROPERTYGET|DISPATCH_METHOD, &ClWork1, ClCell.pdispVal, (LPOLESTR)brdside[ix], 0) != 0 ) {
#endif  //_UNICODE_TABLE
						VariantClear(&ClWork1);
						Use_flag[USE_WORK1] = 0;
						return OLE_ERROR;
					}
//					VariantClear(&ClWork1);//後ろでクリア
//					Use_flag[USE_WORK1] = 0;
				}

				{
					VARIANT result;
					VariantInit(&result);
					if ( AutoWrap(&hr, DISPATCH_PROPERTYGET|DISPATCH_METHOD, &result, ClWork1.pdispVal, L"InnerLineWidth", 0) != 0 ) {
						VariantClear(&result);
						return OLE_ERROR;
					}
					ii = result.lVal;
					VariantClear(&result);
				}
				{
					VARIANT result;
					VariantInit(&result);
					if ( AutoWrap(&hr, DISPATCH_PROPERTYGET|DISPATCH_METHOD, &result, ClWork1.pdispVal, L"OuterLineWidth", 0) != 0 ) {
						VariantClear(&result);
						return OLE_ERROR;
					}
					io = result.lVal;
					VariantClear(&result);
				}
				if ((ii > 80) || (io > 80) || ((ii > 0) && (io > 0) )) {
					hyo[ih*Col_no+iw].line[ix] = 2;
				} else if ((ii> 0) || (io > 0) ) {
					hyo[ih*Col_no+iw].line[ix] = 1;
				} else {
					hyo[ih*Col_no+iw].line[ix] = 0;
				}
//char testdata[100];//全部　1
//SPRINTF(testdata, sizeof(testdata), "%d %d %d ", hyo[ih*Col_no+iw].line[ix], ih*Col_no+iw, ix);
//MessageBox( hWnd, testdata, "", 0);

//------------------------------------------------------------------------------
//セルの線の色取り込み
//------------------------------------------------------------------------------
#if defined(_WIKI) || defined(_HTML)
				{
					VARIANT result;
					VariantInit(&result);
					if ( AutoWrap(&hr, DISPATCH_PROPERTYGET|DISPATCH_METHOD, &result, ClWork1.pdispVal, L"Color", 0) != 0 ) {
						VariantClear(&result);
						return OLE_ERROR;
					}
//char testdata[100];
//SPRINTF(testdata, sizeof(testdata), "BoderColor %d=%d %x ", result.vt, VT_I4, result.lVal);
//MessageBox( hWnd, testdata, "", 0);
					hyo[ih*Col_no+iw].lcolor[ix] = result.lVal;//線には「自動」は無い
					VariantClear(&result);
				}
#endif  //_WIKI _HTML
				VariantClear(&ClWork1);//使い終わったのでクリア
				Use_flag[USE_WORK1] = 0;
			}
//------------------------------------------------------------------------------
//マージ範囲取り込み
//------------------------------------------------------------------------------
			if ( Col_no == 1 && Row_no == 1 ) {
				//セル選択範囲が1つしかない場合はマージとはしない
				hyo[0].merge[AR_FLAG] = 0;
			} else {
				{
					VariantInit(&ClWork2);
					Use_flag[USE_WORK2] = 1;
					if ( AutoWrap(&hr, DISPATCH_PROPERTYGET|DISPATCH_METHOD, &ClWork2, ClSheets.pdispVal, L"getByIndex", 1, 0) != 0 ) {
						VariantClear(&ClWork2);
						Use_flag[USE_WORK2] = 0;
						return OLE_ERROR;
					}
//					VariantClear(&ClWork2);//後ろでクリア
//					Use_flag[USE_WORK2] = 0;
				}
				{
					VariantInit(&ClCursor);
					Use_flag[USE_CURSOR] = 1;
					if ( AutoWrap(&hr, DISPATCH_PROPERTYGET|DISPATCH_METHOD, &ClCursor, ClWork2.pdispVal, L"createCursorByRange", 1, ClCell) != 0 ) {
						VariantClear(&ClCursor);
						Use_flag[USE_CURSOR] = 0;
						return OLE_ERROR;
					}
//					VariantClear(&ClCursor);
//					Use_flag[USE_CURSOR] = 0;
				}

				if ( hyo[ih*Col_no+iw].merge[AR_FLAG] == 0 ) {
					if ( AutoWrap(&hr, DISPATCH_METHOD, NULL, ClCursor.pdispVal, L"collapseToMergedArea", 0) != 0 ) return OLE_ERROR;

					{
						VariantInit(&ClRangeAddress);
						Use_flag[USE_RANGEADDRESS] = 1;
						if ( AutoWrap(&hr, DISPATCH_PROPERTYGET|DISPATCH_METHOD, &ClRangeAddress, ClCursor.pdispVal, L"RangeAddress", 0) != 0 ) {
							VariantClear(&ClRangeAddress);
							Use_flag[USE_RANGEADDRESS] = 0;
							return OLE_ERROR;
						}
//						VariantClear(&ClRangeAddress);//後ろでクリア
//						Use_flag[USE_RANGEADDRESS] = 0;
					}

					for(ix=0; ix<4; ix++) {
						VARIANT result;
						VariantInit(&result);
#ifdef _UNICODE_TABLE
						if ( AutoWrap(&hr, DISPATCH_PROPERTYGET|DISPATCH_METHOD, &result, ClRangeAddress.pdispVal, mrgside[ix], 0) != 0 ) {
#else  //_UNICODE_TABLE
						if ( AutoWrap(&hr, DISPATCH_PROPERTYGET|DISPATCH_METHOD, &result, ClRangeAddress.pdispVal, (LPOLESTR)mrgside[ix], 0) != 0 ) {
#endif  //_UNICODE_TABLE
							VariantClear(&result);
							return OLE_ERROR;
						}
						mrg_wk[ix] = result.lVal;
						VariantClear(&result);
					}
					VariantClear(&ClRangeAddress);//使い終わったのでクリア
					Use_flag[USE_RANGEADDRESS] = 0;

					if ( ( mrg_wk[AR_LEFT] != mrg_wk[AR_RIGHT] ) || ( mrg_wk[AR_TOP] != mrg_wk[AR_BOTTOM] ) ) {
						for(ix=0; ix<4; ix++) {
							hyo[ih*Col_no+iw].merge[ix] = mrg_wk[ix];
						}
						if ( (mrg_wk[AR_RIGHT] > Col_no) || (mrg_wk[AR_BOTTOM] > Row_no) ) {
							irc = CalcEnd(1);
							FreeArea();
							return 2;//起こらないはず
						}
						for ( iw2=mrg_wk[AR_LEFT]; iw2<=mrg_wk[AR_RIGHT]; iw2++ ) {
							for ( ih2=mrg_wk[AR_TOP]; ih2<=mrg_wk[AR_BOTTOM]; ih2++ ) {
								if ( iw2 == mrg_wk[AR_LEFT] ) {
									hyo[ih2*Col_no+iw2].merge[AR_FLAG] = 1;
								} else if ( iw2 == mrg_wk[AR_RIGHT] ) {
									hyo[ih2*Col_no+iw2].merge[AR_FLAG] = 3;
								} else {
									hyo[ih2*Col_no+iw2].merge[AR_FLAG] = 2;
								}
								if ( ih2 == mrg_wk[AR_TOP] ) {
								} else if ( ih2 == mrg_wk[AR_BOTTOM] ) {
									hyo[ih2*Col_no+iw2].merge[AR_FLAG] = hyo[ih2*Col_no+iw2].merge[AR_FLAG] + 6;
								} else {
									hyo[ih2*Col_no+iw2].merge[AR_FLAG] = hyo[ih2*Col_no+iw2].merge[AR_FLAG] + 3;
								}
								hyo[ih2*Col_no+iw2].merge[AR_BASE] = ih*Col_no+iw;
							}
						}
					}
				}
				VariantClear(&ClCursor);//使い終わったのでクリア
				Use_flag[USE_CURSOR] = 0;
				VariantClear(&ClWork2);//使い終わったのでクリア
				Use_flag[USE_WORK2] = 0;
			}
			VariantClear(&ClCell);//使い終わったのでクリア
			Use_flag[USE_CELL] = 0;
		}
		if ( Break_flag == 1 ) {
			irc = MessageDisp( MSG_CANCLE_CODE );
			irc = CalcEnd(1);
			FreeArea();
			Break_flag = 2;
			return CANCEL_RETURN;
		}
		ProgressView(30 + (ih * sabun) / 1000);
	}

	ProgressView(90);
	irc = CalcEnd(1);

	if ( Break_flag == 1 ) {
		irc = MessageDisp( MSG_CANCLE_CODE );
		FreeArea();
		Break_flag = 2;
		return CANCEL_RETURN;
	}
	return NOMAL_RETURN;//エリアは開放しない
}
#endif  //_OLE
