﻿//*****************************************************************************
//* Copyright (c) 2012 Miday Workshop All rights reserved.
//*
//* File: MakeHtml.h
//*****************************************************************************

#ifdef _UNICODE_TABLE

#define LIT_HTML_KEY_BR             L"\n"
#define LIT_HTML_TAG_BR             L"<BR>"
#define LIT_HTML_KEY_BLK            L" "
#define LIT_HTML_KEY_AMP_BLK        L"&nbsp;"
#define LIT_HTML_KEY_QUOT           L"\""
#define LIT_HTML_KEY_AMP_QUOT       L"&quot;"
#define LIT_HTML_KEY_AMP            L"&"
#define LIT_HTML_KEY_AMP_AMP        L"&amp;"
#define LIT_HTML_KEY_LT             L"<"
#define LIT_HTML_KEY_AMP_LT         L"&lt;"
#define LIT_HTML_KEY_GT             L">"
#define LIT_HTML_KEY_AMP_GT         L"&gt;"
#define LIT_HTML_KEY_GT_CAST        (wchar_t*)L">"

#define LIT_HTML_CSS_COLOR          L"color:"
#define LIT_HTML_CSS_FONT_SIZE      L"font-size:%dpt"
#define LIT_HTML_CSS_FONT_WEICHT    L"font-weight:bold"
#define LIT_HTML_CSS_FONT_STYLE     L"font-style:italic"
#define LIT_HTML_CSS_UNDERLINE      L" underline"
#define LIT_HTML_CSS_LINE_THROUGT   L" line-through"

#define LIT_HTML_RGB                (wchar_t*)L"#%2.2x%2.2x%2.2x"

#define LIT_HTML_TAG_B_S            (wchar_t*)L"<B>"
#define LIT_HTML_TAG_I_S            (wchar_t*)L"<I>"
#define LIT_HTML_TAG_P_CENTER       (wchar_t*)L"<P ALIGN=\"CENTER\""
#define LIT_HTML_TAG_P_LEFT         (wchar_t*)L"<P ALIGN=\"LEFT\""
#define LIT_HTML_TAG_P_RIGHT        (wchar_t*)L"<P ALIGN=\"RIGHT\""
#define LIT_HTML_TAG_P_S            (wchar_t*)L"<P"
#define LIT_HTML_TAG_S_S            (wchar_t*)L"<S>"
#define LIT_HTML_TAG_SPAN_S         (wchar_t*)L"<SPAN STYLE=\""
#define LIT_HTML_TAG_STYLE_S        (wchar_t*)L"<style type=\"text/css\">"
#define LIT_HTML_TAG_TABLE_S        (wchar_t*)L"<TABLE"
#define LIT_HTML_TAG_TD_S           (wchar_t*)L"<TD"
#define LIT_HTML_TAG_TR_S           (wchar_t*)L"<TR>"
#define LIT_HTML_TAG_U_S            (wchar_t*)L"<U>"
#define LIT_HTML_TAG_B_E            (wchar_t*)L"</B>"
#define LIT_HTML_TAG_I_E            (wchar_t*)L"</I>"
#define LIT_HTML_TAG_P_E            (wchar_t*)L"</P>"
#define LIT_HTML_TAG_S_E            (wchar_t*)L"</S>"
#define LIT_HTML_TAG_SPAN_E         (wchar_t*)L"</SPAN>"
#define LIT_HTML_TAG_STYLE_E        (wchar_t*)L"</style>"
#define LIT_HTML_TAG_TABLE_E        (wchar_t*)L"</TABLE>"
#define LIT_HTML_TAG_TD_E           (wchar_t*)L"</TD>"
#define LIT_HTML_TAG_TR_E           (wchar_t*)L"</TR>"
#define LIT_HTML_TAG_U_E            (wchar_t*)L"</U>"
#define LIT_HTML_TAG_QUOTATION_END  (wchar_t*)L"\">"
#define LIT_HTML_TAG_COM_S          (wchar_t*)L"<!--"
#define LIT_HTML_TAG_COM_E          (wchar_t*)L"-->"

#define LIT_HTML_NOWRAP             (wchar_t*)L" NOWRAP"
#define LIT_HTML_ROWSPAN            (wchar_t*)L" ROWSPAN=%d"
#define LIT_HTML_BOTTOM             (wchar_t*)L" VALIGN=\"BOTTOM\""
#define LIT_HTML_TOP                (wchar_t*)L" VALIGN=\"TOP\""
#define LIT_HTML_COLSPAN            (wchar_t*)L" COLSPAN=%d"

#define LIT_HTML_BGCOLOR            (wchar_t*)L" BGCOLOR="
#define LIT_HTML_BORDER_CELLSPACING (wchar_t*)L" BORDER CELLSPACING=%d"
#define LIT_HTML_BORDER_C           (wchar_t*)L" border: "
#define LIT_HTML_BORDER             (wchar_t*)L" BORDER"
#define LIT_HTML_BORDERCOLOR        (wchar_t*)L" BORDERCOLOR="
#define LIT_HTML_CLS_C              (wchar_t*)L" class=\"ctowebC%d\""
#define LIT_HTML_CLS_F              (wchar_t*)L" class=\"ctowebF%d\""
#define LIT_HTML_CLS_T              (wchar_t*)L" CLASS=\"ctowebT\""
#define LIT_HTML_PARM_F             (wchar_t*)L"p.ctowebF%d {"
#define LIT_HTML_PARM_T             (wchar_t*)L"table.ctowebT, td.ctowebT, th.ctowebT { border: "
#define LIT_HTML_PARM_C             (wchar_t*)L"td.ctowebC%d {"
#define LIT_HTML_BACK_COLOR         (wchar_t*)L"background-color:"
#define LIT_HTML_TEXT_DECO          (wchar_t*)L"text-decoration:"

#define LIT_HTML_DPX                (wchar_t*)L"%dpx "
#define LIT_HTML_COLOR              (wchar_t*)L"COLOR:"
#define LIT_HTML_FONT_SIZE          (wchar_t*)L"FONT-SIZE:%dpt"
#define LIT_HTML_SOLID              (wchar_t*)L"solid}"
#define LIT_HTML_KEY_SEMI           (wchar_t*)L";"
#define LIT_HTML_KEY_RIGHT_CURLY    (wchar_t*)L"}"

#else  //_UNICODE_TABLE

#define LIT_HTML_KEY_BR             "\n"
#define LIT_HTML_TAG_BR             "<BR>"
#define LIT_HTML_KEY_AMP_BLK        "&nbsp;"
#define LIT_HTML_KEY_QUOT           "\""
#define LIT_HTML_KEY_AMP_QUOT       "&quot;"
#define LIT_HTML_KEY_AMP            "&"
#define LIT_HTML_KEY_AMP_AMP        "&amp;"
#define LIT_HTML_KEY_LT             "<"
#define LIT_HTML_KEY_AMP_LT         "&lt;"
#define LIT_HTML_KEY_GT             ">"
#define LIT_HTML_KEY_AMP_GT         "&gt;"
#define LIT_HTML_KEY_GT_CAST        ">"

#define LIT_HTML_CSS_COLOR          "color:"
#define LIT_HTML_CSS_FONT_SIZE      "font-size:%dpt"
#define LIT_HTML_CSS_FONT_WEICHT    "font-weight:bold"
#define LIT_HTML_CSS_FONT_STYLE     "font-style:italic"
#define LIT_HTML_CSS_UNDERLINE      " underline"
#define LIT_HTML_CSS_LINE_THROUGT   " line-through"

#define LIT_HTML_RGB                "#%2.2x%2.2x%2.2x"

#define LIT_HTML_TAG_B_S            "<B>"
#define LIT_HTML_TAG_I_S            "<I>"
#define LIT_HTML_TAG_P_CENTER       "<P ALIGN=\"CENTER\""
#define LIT_HTML_TAG_P_LEFT         "<P ALIGN=\"LEFT\""
#define LIT_HTML_TAG_P_RIGHT        "<P ALIGN=\"RIGHT\""
#define LIT_HTML_TAG_P_S            "<P"
#define LIT_HTML_TAG_S_S            "<S>"
#define LIT_HTML_TAG_SPAN_S         "<SPAN STYLE=\""
#define LIT_HTML_TAG_STYLE_S        "<style type=\"text/css\">"
#define LIT_HTML_TAG_TABLE_S        "<TABLE"
#define LIT_HTML_TAG_TD_S           "<TD"
#define LIT_HTML_TAG_TR_S           "<TR>"
#define LIT_HTML_TAG_U_S            "<U>"
#define LIT_HTML_TAG_B_E            "</B>"
#define LIT_HTML_TAG_I_E            "</I>"
#define LIT_HTML_TAG_P_E            "</P>"
#define LIT_HTML_TAG_S_E            "</S>"
#define LIT_HTML_TAG_SPAN_E         "</SPAN>"
#define LIT_HTML_TAG_STYLE_E        "</style>"
#define LIT_HTML_TAG_TABLE_E        "</TABLE>"
#define LIT_HTML_TAG_TD_E           "</TD>"
#define LIT_HTML_TAG_TR_E           "</TR>"
#define LIT_HTML_TAG_U_E            "</U>"
#define LIT_HTML_TAG_QUOTATION_END  "\">"
#define LIT_HTML_TAG_COM_S          "<!--"
#define LIT_HTML_TAG_COM_E          "-->"

#define LIT_HTML_NOWRAP             " NOWRAP"
#define LIT_HTML_ROWSPAN            " ROWSPAN=%d"
#define LIT_HTML_BOTTOM             " VALIGN=\"BOTTOM\""
#define LIT_HTML_TOP                " VALIGN=\"TOP\""
#define LIT_HTML_COLSPAN            " COLSPAN=%d"

#define LIT_HTML_BGCOLOR            " BGCOLOR="
#define LIT_HTML_BORDER_CELLSPACING " BORDER CELLSPACING=%d"
#define LIT_HTML_BORDER_C           " border: "
#define LIT_HTML_BORDER             " BORDER"
#define LIT_HTML_BORDERCOLOR        " BORDERCOLOR="
#define LIT_HTML_CLS_C              " class=\"ctowebC%d\""
#define LIT_HTML_CLS_F              " class=\"ctowebF%d\""
#define LIT_HTML_CLS_T              " CLASS=\"ctowebT\""
#define LIT_HTML_PARM_F             "p.ctowebF%d {"
#define LIT_HTML_PARM_T             "table.ctowebT, td.ctowebT, th.ctowebT { border: "
#define LIT_HTML_PARM_C             "td.ctowebC%d {"
#define LIT_HTML_BACK_COLOR         "background-color:"
#define LIT_HTML_TEXT_DECO          "text-decoration:"

#define LIT_HTML_DPX                "%dpx "
#define LIT_HTML_COLOR              "COLOR:"
#define LIT_HTML_FONT_SIZE          "FONT-SIZE:%dpt"
#define LIT_HTML_SOLID              "solid}"
#define LIT_HTML_KEY_SEMI           ";"
#define LIT_HTML_KEY_RIGHT_CURLY    "}"

#endif  //_UNICODE_TABLE
