//*****************************************************************************
//* Copyright (c) 2012 Miday Workshop All rights reserved.
//*
//* File: FileIo.h
//*****************************************************************************

#define CLIP_WAITCOUNT 20
#define CLIP_WAITTIME  50
#define CLIP_ASCIIWIDE 1
#define CLIP_HORIWIDE  2

#ifdef _UNICODE_TABLE

#define CLIP_WAITCOUNT_S          (wchar_t*)L"20"
#define CLIP_WAITTIME_S           (wchar_t*)L"50"
#define CLIP_ASCIIWIDE_S          (wchar_t*)L"1"
#define CLIP_HORIWIDE_S           (wchar_t*)L"2"

#define INI_KEYL                  (wchar_t*)L"["
#define INI_KEYR                  (wchar_t*)L"]"
#define INI_EQL                   (wchar_t*)L"="

#define INI_COMMENT               (wchar_t)L';'

#define INI_KEY1                  (wchar_t*)L"Log"
#define INI_KEY2                  (wchar_t*)L"Wait"
#define INI_KEY3                  (wchar_t*)L"Param"
#define INI_KEY4                  (wchar_t*)L"Path"

#define INI_AT_S                  (wchar_t*)L"@"
#define INI_5_S                   (wchar_t*)L"5"

#define INI_CLIPWAITCOUNT         (wchar_t*)L"ClipWaitCount"
#define INI_CLIPWAITTIME          (wchar_t*)L"ClipWaitTime"
#define INI_TIME                  (wchar_t*)L"Time"
#define INI_ASCIIWIDE             (wchar_t*)L"AsciiWide"
#define INI_HORIWIDE              (wchar_t*)L"HoriWide"
#define INI_LOCALE                (wchar_t*)L"Locale"
#define INI_EVASION               (wchar_t*)L"Evasion"

#define INI_CNTL_CHAR             (wchar_t*)L"cntl_char"
#define INI_LINE_COLOR            (wchar_t*)L"line_color"
#define INI_LINE_WIDTH            (wchar_t*)L"line_width"
#define INI_BACK_COLOR            (wchar_t*)L"back_color"
#define INI_FONT_COLOR            (wchar_t*)L"font_color"
#define INI_FONT_SIZE             (wchar_t*)L"font_size"
#define INI_FONT_BOLD             (wchar_t*)L"font_bold"
#define INI_FONT_UNDERLINE        (wchar_t*)L"font_underline"
#define INI_FONT_ITALIC           (wchar_t*)L"font_italic"
#define INI_FONT_STRIKETHROUGH    (wchar_t*)L"font_strikethrough"
#define INI_CELL_POSHR            (wchar_t*)L"cell_poshr"
#define INI_CELL_POSHC            (wchar_t*)L"cell_poshc"
#define INI_CELL_POSHL            (wchar_t*)L"cell_poshl"
#define INI_CELL_POSVT            (wchar_t*)L"cell_posvt"
#define INI_CELL_POSVC            (wchar_t*)L"cell_posvc"
#define INI_CELL_POSVB            (wchar_t*)L"cell_posvb"
#define INI_CELL_SEP              (wchar_t*)L"cell_sep"
#define INI_CELL_MRGH             (wchar_t*)L"cell_mrgh"
#define INI_CELL_MRGV             (wchar_t*)L"cell_mrgv"
#define INI_CODE_CHENGE_M         (wchar_t*)L"code_chenge_m"
#define INI_CODE_CHENGE_O         (wchar_t*)L"code_chenge_o"
#define INI_CODE_CHENGE_R         (wchar_t*)L"code_chenge_r"

#define INI_HTMLVERSION           (wchar_t*)L"htmlversion"
#define INI_TABLE_POSH            (wchar_t*)L"table_posh"
#define INI_TABLE_OUTLINE         (wchar_t*)L"table_outline"
#define INI_LINE_COLOR_YN         (wchar_t*)L"line_color_yn"
#define INI_LINE_WIDTH_YN         (wchar_t*)L"line_width_yn"
#define INI_BACK_COLOR_YN         (wchar_t*)L"back_color_yn"
#define INI_FONT_COLOR_YN         (wchar_t*)L"font_color_yn"
#define INI_FONT_SIZE_YN          (wchar_t*)L"font_size_yn"
#define INI_FONT_BOLD_YN          (wchar_t*)L"font_bold_yn"
#define INI_FONT_UNDERLINE_YN     (wchar_t*)L"font_underline_yn"
#define INI_FONT_ITALIC_YN        (wchar_t*)L"font_italic_yn"
#define INI_FONT_STRIKETHROUGH_YN (wchar_t*)L"font_strikethrough_yn"
#define INI_CELL_POSH_YN          (wchar_t*)L"cell_posh_yn"
#define INI_CELL_POSV_YN          (wchar_t*)L"cell_posv_yn"

#define INI_OFFICE_PATH           (wchar_t*)L"Office_path"
#define INI_RDB_PATH              (wchar_t*)L"Rdb_path"

#else  //_UNICODE_TABLE

#define CLIP_WAITCOUNT_S          "20"
#define CLIP_WAITTIME_S           "50"
#define CLIP_ASCIIWIDE_S          "1"
#define CLIP_HORIWIDE_S           "2"

#define INI_KEYL                  "["
#define INI_KEYR                  "]"
#define INI_EQL                   "="

#define INI_COMMENT               L';'

#define INI_KEY1                  "Log"
#define INI_KEY2                  "Wait"
#define INI_KEY3                  "Param"
#define INI_KEY4                  "Path"

#define INI_AT_S                  "@"
#define INI_5_S                   "5"

#define INI_CLIPWAITCOUNT         "ClipWaitCount"
#define INI_CLIPWAITTIME          "ClipWaitTime"
#define INI_TIME                  "Time"
#define INI_ASCIIWIDE             "AsciiWide"
#define INI_HORIWIDE              "HoriWide"
#define INI_LOCALE                "Locale"
#define INI_EVASION               "Evasion"

#define INI_CNTL_CHAR             "cntl_char"
#define INI_LINE_COLOR            "line_color"
#define INI_LINE_WIDTH            "line_width"
#define INI_BACK_COLOR            "back_color"
#define INI_FONT_COLOR            "font_color"
#define INI_FONT_SIZE             "font_size"
#define INI_FONT_BOLD             "font_bold"
#define INI_FONT_UNDERLINE        "font_underline"
#define INI_FONT_ITALIC           "font_italic"
#define INI_FONT_STRIKETHROUGH    "font_strikethrough"
#define INI_CELL_POSHR            "cell_poshr"
#define INI_CELL_POSHC            "cell_poshc"
#define INI_CELL_POSHL            "cell_poshl"
#define INI_CELL_POSVT            "cell_posvt"
#define INI_CELL_POSVC            "cell_posvc"
#define INI_CELL_POSVB            "cell_posvb"
#define INI_CELL_SEP              "cell_sep"
#define INI_CELL_MRGH             "cell_mrgh"
#define INI_CELL_MRGV             "cell_mrgv"
#define INI_CODE_CHENGE_M         "code_chenge_m"
#define INI_CODE_CHENGE_O         "code_chenge_o"
#define INI_CODE_CHENGE_R         "code_chenge_r"

#define INI_HTMLVERSION           "htmlversion"
#define INI_TABLE_POSH            "table_posh"
#define INI_TABLE_OUTLINE         "table_outline"
#define INI_LINE_COLOR_YN         "line_color_yn"
#define INI_LINE_WIDTH_YN         "line_width_yn"
#define INI_BACK_COLOR_YN         "back_color_yn"
#define INI_FONT_COLOR_YN         "font_color_yn"
#define INI_FONT_SIZE_YN          "font_size_yn"
#define INI_FONT_BOLD_YN          "font_bold_yn"
#define INI_FONT_UNDERLINE_YN     "font_underline_yn"
#define INI_FONT_ITALIC_YN        "font_italic_yn"
#define INI_FONT_STRIKETHROUGH_YN "font_strikethrough_yn"
#define INI_CELL_POSH_YN          "cell_posh_yn"
#define INI_CELL_POSV_YN          "cell_posv_yn"

#define INI_OFFICE_PATH           "Office_path"
#define INI_RDB_PATH              "Rdb_path"

#endif  //_UNICODE_TABLE
