//*****************************************************************************
//* Copyright (c) 2012 Miday Workshop All rights reserved.
//*
//* File: MsgDisp.cpp
//*****************************************************************************

#ifdef _WINDOWS_PLAT
#include <windows.h>
#else  //_WINDOWS_PLAT
#include <gtk/gtk.h>
#include <unistd.h>
#include <stdint.h>
extern GtkWidget *window;
#endif  //_WINDOWS_PLAT
#include <stdio.h>
#include <string.h>
#include "CalcDef.h"
#include "MsgLocale.h"

//==============================================================================
//bZ[W\
//==============================================================================
int MessageDisp(int msg_no) {
#ifdef _WINDOWS_PLAT
	unsigned int style;
	int result;
#else  //_WINDOWS_PLAT
	GtkMessageType icontype;
	GtkButtonsType buttontype;
	GtkWidget *msgbox;
	gint result;
#endif  //_WINDOWS_PLAT
	const char *msgdata;
	char msg[500];

	switch(msg_no) {
	case MSG_NOMAL_CODE:
	case MSG_NOMAL_TIME_CODE:
	case MSG_CANCLE_CODE:
#if defined(_WIKI) || defined(_HTML)
	case MSG_ER_INIT_CODE:
#endif  //_WIKI _HTML
#ifdef _WINDOWS_PLAT
		style = MB_OK | MB_ICONINFORMATION;
#else  //_WINDOWS_PLAT
		icontype   = GTK_MESSAGE_INFO;
		buttontype = GTK_BUTTONS_OK;
#endif  //_WINDOWS_PLAT
		break;
	case MSG_ALL_LINE_CODE:
	case MSG_ER_APP_CODE:
#ifdef _WINDOWS_PLAT
		style = MB_OKCANCEL | MB_ICONQUESTION;
#else  //_WINDOWS_PLAT
		icontype   = GTK_MESSAGE_QUESTION;
		buttontype = GTK_BUTTONS_OK_CANCEL;
#endif  //_WINDOWS_PLAT
		break;
	default:
#ifdef _WINDOWS_PLAT
		style = MB_OK | MB_ICONSTOP;
#else  //_WINDOWS_PLAT
		icontype   = GTK_MESSAGE_ERROR;
		buttontype = GTK_BUTTONS_OK;
#endif  //_WINDOWS_PLAT
		break;
	}

	switch(msg_no) {
	case MSG_NOMAL_CODE:
		msgdata = MSG_NOMAL;
		break;
	case MSG_NOMAL_TIME_CODE:
#ifdef _WINDOWS_PLAT
#ifdef _UNICODE_TABLE
		sprintf_s(msg, sizeof(msg), MSG_NOMAL_TIME, Tmin, Tsec);
#else  //_UNICODE_TABLE
		SPRINTF(msg, sizeof(msg), MSG_NOMAL_TIME, Tmin, Tsec);
#endif  //_UNICODE_TABLE
#else  //_WINDOWS_PLAT
		sprintf(msg, MSG_NOMAL_TIME, Tmin, Tsec);
#endif  //_WINDOWS_PLAT
		msgdata = msg;
		break;
	case MSG_ALL_LINE_CODE:
		msgdata = MSG_ALL_LINE;
		break;
	case MSG_CANCLE_CODE:
		msgdata = MSG_CANCLE;
		break;
	case MSG_ER_CNV_CODE:
		msgdata = MSG_ER_CNV;
		break;
	case MSG_ER_APP_CODE :
		msgdata = MSG_ER_APP;
		break;

	case MSG_ER_MEM1_CODE:
		msgdata = MSG_ER_MEM1;
		break;
	case MSG_ER_MEM2_CODE:
		msgdata = MSG_ER_MEM2;
		break;
	case MSG_ER_MEM3_CODE:
		msgdata = MSG_ER_MEM3;
		break;

	case MSG_ER_CAL1_CODE:
		msgdata = MSG_ER_CAL1;
		break;
	case MSG_ER_CAL2_CODE:
		msgdata = MSG_ER_CAL2;
		break;

	case MSG_ER_CLP1_CODE:
		msgdata = MSG_ER_CLP1;
		break;
	case MSG_ER_CLP2_CODE:
		msgdata = MSG_ER_CLP2;
		break;
	case MSG_ER_CLP3_CODE:
		msgdata = MSG_ER_CLP3;
		break;
	case MSG_ER_CLP4_CODE:
		msgdata = MSG_ER_CLP4;
		break;
	case MSG_ER_CLP5_CODE:
		msgdata = MSG_ER_CLP5;
		break;
	case MSG_ER_CLP6_CODE:
		msgdata = MSG_ER_CLP6;
		break;
	case MSG_ER_CLP7_CODE:
		msgdata = MSG_ER_CLP7;
		break;
	case MSG_ER_CLP8_CODE:
		msgdata = MSG_ER_CLP8;
		break;
	case MSG_ER_CLP9_CODE:
		msgdata = MSG_ER_CLP9;
		break;
	case MSG_ER_CHAR_CODE:
		msgdata = MSG_ER_CHAR;
		break;

#if defined(_WIKI) || defined(_HTML)
	case MSG_ER_INIT_CODE:
		msgdata = MSG_ER_INIT;
		break;
#endif  //_WIKI _HTML
	case MSG_ER_INIR_CODE://Linux̂
		msgdata = MSG_ER_INIR;
		break;

#ifdef _SDK
	case MSG_ER_RDB_CODE:
		msgdata = MSG_ER_RDB;
		break;
	case MSG_ER_SER_CODE:
		msgdata = MSG_ER_SER;
		break;
	case MSG_ER_PATH_CODE:
		msgdata = MSG_ER_PATH;
		break;
#endif  //_SDK

	case MSG_ER_AREA_CODE:
		msgdata = MSG_ER_AREA;
		break;
	case MSG_ER_SYSTEM_CODE:
		msgdata = MSG_ER_SYSTEM;
		break;
	default:
		return 0;
	}

#ifdef _WINDOWS_PLAT
	result = MessageBox( hWnd, msgdata, APP_NAME, style );
#else  //_WINDOWS_PLAT
	msgbox = gtk_message_dialog_new (GTK_WINDOW(window),
			(GtkDialogFlags)(GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT),
			icontype, buttontype, "%s", msgdata);

//usleep(300);
	gtk_window_set_position(GTK_WINDOW(window), GTK_WIN_POS_CENTER);
	Window_Refresh();

	gtk_window_set_title (GTK_WINDOW (msgbox), APP_NAME);
	if ( buttontype == GTK_BUTTONS_OK_CANCEL ) {
		gtk_dialog_set_default_response (GTK_DIALOG (msgbox), GTK_RESPONSE_OK);
	}

//usleep(900);
	result = gtk_dialog_run (GTK_DIALOG (msgbox));
	gtk_widget_destroy (msgbox);
//usleep(5000);
//sleep(1);
//Window_Refresh();
#endif  //_WINDOWS_PLAT
	return result;
}

